/*
 * oscp-parse-mp3.c
 * Copyright (C) 2015 KotCzarny <tjosko@yahoo.com>
 *
 *  This program is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the
 *  Free Software Foundation; either version 2 of the License, or (at your
 *  option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include <stdio.h>
#include <string.h>

void cs(char *msg);
void dlog(int l, char *msg);

/////#######################################
void parse_id3v2(FILE *f, int start, int ts) { int i, s, offs, ss=150;
 static unsigned char c[168]; //, b0, b1, b2, b3;
 while(ftell(f)<start+ts+10 && fread(c, 10, 1, f)>0) {
  if(c[4]==0 &&c[5]==0 &&c[6]==0 &&c[7]==0) { return; }
  if(c[4]>127||c[5]>127||c[6]>127||c[7]>127) {
//   printf("bad tag size (not synch safe: %02x %02x %02x %02x)\n", c[4], c[5], c[6], c[7]);
   s=(c[4]<<24)+(c[5]<<16)+(c[6]<<8)+c[7];
   // return;
  } else s=(c[4]<<21)+(c[5]<<14)+(c[6]<<7)+c[7];
  fread(c+10, (s>ss?ss:s), 1, f); if(s>ss) fseek(f, s-ss, SEEK_CUR);
  if(s>ss) c[10+ss]=0; else c[10+s]=0;
if(c[0]!=0 && s>0) { offs=0;
 if(c[10]==0x00) { offs=1; for(i=10+offs; i<10+offs+s-1; i++) if(c[i]==0x00) c[i]=*" "; }
 if(c[10]==0x01) { offs=1; /* deutf16(c, 10+offs, (s>ss?ss:s)-offs); */ }
}
 }
}

// int frames=0, errors=0;

////##############
int p_error(int a) { return 1; }

////##################
int parse_mp3(FILE *f) { static unsigned char c[128],cc; char *csp=(char *)c; int ts,start, err=0;
 int V=0,vv=0,L=0,B=0,F=0, PA,CH, FL; int fff=0, frames=0;

 static int freqs[3][4]={ {44100,48000,32000,0}, {22050,24000,16000,0}, {11025,12000,8000,0} };
 static int bitrates[5][16]={
{0,32,64,96,128,160,192,224,256,288,320,352,384,416,448,-1},
{0,32,48,56,64,80,96,112,128,160,192,224,256,320,384,-1},
{0,32,40,48,56,64,80,96,112,128,160,192,224,256,320,-1},
{0,32,48,56,64,80,96,112,128,144,160,176,192,224,256,-1},
{0,8,16,24,32,40,48,56,64,80,96,112,128,144,160,-1} };

 while(fread(c, 1, 1, f)>0) {
  if(c[0]==255) {
   if(fread(c+1, 1, 1, f)>0 && (c[1]&0xe0)) // 0b11100000
   { ts=ftell(f)-2; fread(c+2, 2, 1, f);
// 0b00011000, 0b00001000
    switch(c[1]&0x18) { case 0: V=25; break; case 0x08: V=00; break;
// 0b00010000, 0b00011000
     case 0x10: V=20; break; case 0x18: V=10; break; } 
// 0b00000110, 0b00000010
    switch(c[1]&0x06) { case 0: L=0; break; case 0x02: L=3; break;
// 0b00000100, 0b00000110:
     case 0x04: L=2; break; case 0x06: L=1; break; }

    cc=c[2]>>4; if(V==10 && L==1) B=bitrates[0][cc]; else if(V==10 && L==2) B=bitrates[1][cc];
    else if(V==10 && L==3) B=bitrates[2][cc]; else if(V>=20 && L==1) B=bitrates[3][cc];
    else if(V>=20 && L>=2) B=bitrates[4][cc];

    switch(V) { case 10: vv=0; break; case 20: vv=1; break; case 25: vv=2; break; }

// &0b00001100
    switch(c[2]&0x0c) { // 0b00000100
     case 0: F=freqs[vv][0]; break; case 0x04: F=freqs[vv][1]; break;
// 0b00001000, 0b00001100
     case 0x08: F=freqs[vv][2]; break; case 0x0c: F=freqs[vv][3]; break;
    }
// 0b00000010
    if(c[2]&0x02) PA=1; else PA=0;   //if(c[2]&0b00000001) PR=1; else PR=0;
// 0b11000000
    if(c[3]&0xc0) CH=1; else CH=2;   //if(c[3]&0b00001000) CP=1; else CP=0;
    //if(c[3]&0b00000100) OR=1; else OR=0; //if(c[3]&0b00000011) EM=1; else EM=0;

    int PA1=0; if(PA) switch(L) { case 1: PA1=4; break; case 2: case 3: PA1=1; break; }
    FL=(int)(144.0*B*1000.0/F)+PA1;

    if(0) { if(fff==0) { fff++; printf("[%5d] V:%d(%d), L:%d, B:%d, F:%d, CH:%d, FL:%d, PA:%d\n",
     frames, V, vv, L, B, F, CH, FL, PA); } }

    if(V>0 && L>0 && B>0 && F>0 && CH>0 && FL>0) { err=0; fseek(f, FL-4, SEEK_CUR); frames++;
     if(0 && frames%1500==1) printf("[%5d] V:%d, L:%d, B:%d, F:%d, CH:%d, fl:%d, PA:%d\n",
      frames, V, L, B, F, CH, FL, PA);
    } else { err=1; p_error(ftell(f)-3); fseek(f, -3, SEEK_CUR); dlog(9,"e1"); }

   } else { err++; p_error(ftell(f)-1); if(0)fseek(f, -1, SEEK_CUR); dlog(9,"e2"); }
  } else if((c[0]==*"I" || c[0]==*"3")) {
   if(fread(c+1, 2, 1, f) && (strncmp(csp, "ID3", 3)==0 || strncmp(csp, "3DI", 3)==0))
   { err=0; start=ftell(f)-3; fread(c+3, 7, 1, f);
//    flags=c[5];
    if(c[6]>127 || c[7]>127 || c[8]>127 || c[9]>127) { ts=0; printf("bad ID3v2 size\n"); }
    else { ts=(c[6]<<21)+(c[7]<<14)+(c[8]<<7)+c[9]; if(ts<0) ts=0; }
    printf("\nfound ID3v2.%d.%d, start: %d, ts: %d\n", c[3], c[4], start, ts);
    if(0&&ts>0) { parse_id3v2(f, start, ts); printf("\n"); }
    if(ts>0) fseek(f, start+10+ts, SEEK_SET);
    else { err++; fseek(f, start+1, SEEK_SET); dlog(9,"e3"); }
   } else { err++; fseek(f, -2, SEEK_CUR); dlog(9,"e4"); }
  } else if(c[0]==*"T") {
   if(fread(c+1, 2, 1, f)>0 && strncmp(csp, "TAG", 3)==0) { err=0; start=ftell(f)-3;
    fread(c+3, 125, 1, f);
   } else { err++; fseek(f, -2, SEEK_CUR); dlog(9,"e5"); }
  } else { err++; dlog(9,"e6"); }
  if(err==1) { p_error(ftell(f)-1); dlog(9,"e7"); }
 }
 return frames;
}
////##########################
int get_mp3_duration(char *fn) { // int i=0, fs=0;
 int frames=0;
 if(0) printf("%s\n", fn);

 FILE *f; f=fopen(fn,"r"); if(!f) { cs("Info: get_mp3_duration: can't open file\n"); return -1; }
// fseek(f, 0, SEEK_END); fs=ftell(f); fseek(f, 0, SEEK_SET);
 frames=parse_mp3(f); fclose(f);

// char lmsg[1024]; sprintf(lmsg, "Info: frames: %d, errors: %d\n", frames, errors); cs(lmsg);

 return (int)(1.0/38.4*frames);
}
