/*
 * oscp-slave-xmp.c
 * Copyright (C) 2015 KotCzarny <tjosko@yahoo.com>
 *
 *  This program is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the
 *  Free Software Foundation; either version 2 of the License, or (at your
 *  option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include "oscp-slave.h"

#include <xmp.h>

xmp_context xmpc; struct xmp_frame_info xmpfi;

int xmpstate=0; float xmpcur=0, xmpdur=0; int xmpi=0;

/////###############
void xmp_show_supp() {
// char **fo=xmp_get_format_list(), f[128]; int i=0, j;
 printf("  [slave-xmp]: based on libxmp-"XMP_VERSION"");
 printf(", formats: mod, med, xm, it, s3m, dbm, psm, umx, okt, digi, 669, mtm, mtp, ac1d, di, eu"
 ", kris, lax, liq, dtm, ptm, rtm, stm, amf, dmf, imf, amd, rad, hsc\n");

/* printf("\n formats:"); while(fo[i])
 { if(i>0) printf(",");
  // to lowercase
  strncpy(f, fo[i], 127);
  for(j=0;j<strlen(fo[i]);j++) if(fo[i][j]>=*"A" && fo[i][j]<=*"Z") f[j]+=32;

  printf(" %s", f); i++; } printf("\n"); */

}

/////###########
//void xmp_flush() { lf("xmp_flush"); adev_flush(); }
/////##########
void xmp_init() { lf("xmp_init"); xmpstate=0; dlog(9, "xmp_init"); if(xmpstate>0) return;
 xmpc=xmp_create_context();

 if(adev_init()<=0) { xmpstate=0; return; }

 xmpstate=1;
}
/////##########
void xmp_stop() { lf("xmp_stop");
 dlog(9, "xmp_stop");
 if(xmpstate<=1) return;

 if(xmpstate>=3) { xmp_end_player(xmpc); xmp_release_module(xmpc); }

 xmpstate=1;
}
/////#########
void xmp_end() { lf("xmp_end");
 dlog(9, "xmp_end"); if(xmpstate>1) xmp_stop(); adev_end();
 if(xmpc) xmp_free_context(xmpc);
 xmpstate=0; 
}
/////##################
void xmp_die(char *msg) { lf2("xmp_die",msg); dlog(9, "xmp_die"); xmp_stop(); cs(msg); }

/////#########################
void xmp_update_info(char *fn) { lf2("xmp_update_info", fn);
 static char lmsg[4096]; int fs=get_filesize(fn);

 struct xmp_module_info xmpmi;
 xmp_get_module_info(xmpc, &xmpmi);
//snprintf(lmsg,4095,"xmpmi: md5: %s", xmpmi.md5); dlog(9,lmsg);
//snprintf(lmsg,4095,"xmpmi: vol_base: %d", xmpmi.vol_base); dlog(9,lmsg);
//snprintf(lmsg,4095,"xmpmi: comment: %s", xmpmi.comment); dlog(9,lmsg);
//snprintf(lmsg,4095,"xmpmi: num_seq: %d", xmpmi.num_sequences); dlog(9,lmsg);
 char *bn=get_basename(fn);
if(xmpmi.mod->name) { snprintf(lmsg,4095,"Title: %s (%s)\n", xmpmi.mod->name, bn); cs(lmsg); }
else { snprintf(lmsg,4095,"Title: %s\n", bn); cs(lmsg); }

//snprintf(lmsg,4095,"Artist: %s\n", bn); cs(lmsg);

if(xmpmi.comment) snprintf(lmsg,4095,"Comment: %d, %d, %s, %s\n", fs, xmpmi.num_sequences,
 xmpmi.mod->type, xmpmi.comment);
else snprintf(lmsg,4095,"Comment: %d, %d, %s\n", fs, xmpmi.num_sequences, xmpmi.mod->type); cs(lmsg);
//snprintf(lmsg,4095,"xmpmi: pat: %d", xmpmi.mod->pat); dlog(9,lmsg);
//snprintf(lmsg,4095,"xmpmi: trk: %d", xmpmi.mod->trk); dlog(9,lmsg);
//snprintf(lmsg,4095,"xmpmi: chn: %d", xmpmi.mod->chn); dlog(9,lmsg);
//snprintf(lmsg,4095,"xmpmi: ins: %d", xmpmi.mod->ins); dlog(9,lmsg);
//snprintf(lmsg,4095,"xmpmi: smp: %d", xmpmi.mod->smp); dlog(9,lmsg);
//snprintf(lmsg,4095,"xmpmi: spd: %d", xmpmi.mod->spd); dlog(9,lmsg);
//snprintf(lmsg,4095,"xmpmi: bpm: %d", xmpmi.mod->bpm); dlog(9,lmsg);
//snprintf(lmsg,4095,"xmpmi: len: %d", xmpmi.mod->len); dlog(9,lmsg);
//snprintf(lmsg,4095,"xmpmi: rst: %d", xmpmi.mod->rst); dlog(9,lmsg);
//snprintf(lmsg,4095,"xmpmi: gvl: %d", xmpmi.mod->gvl); dlog(9,lmsg);
/*
[1 9 0 xmpmi: vol_base: 64]
[1 9 0 xmpmi: comment: (null)]
[1 9 0 xmpmi: num_seq: 1]
[1 9 0 xmpmi: name: ]
[1 9 0 xmpmi: type: Protracker M.K.]
[1 9 0 xmpmi: pat: 22]
[1 9 0 xmpmi: trk: 88]
[1 9 0 xmpmi: chn: 4]
[1 9 0 xmpmi: ins: 31]
[1 9 0 xmpmi: smp: 31]
[1 9 0 xmpmi: spd: 6]
[1 9 0 xmpmi: bpm: 125]
[1 9 0 xmpmi: len: 28]
[1 9 0 xmpmi: rst: 0]
[1 9 0 xmpmi: gvl: 64]
*/

 sprintf(lmsg, "AUDIO: %d Hz, %d ch, xxx, %d kbit\n", sformat.rate,
 (1?xmpmi.mod->chn:sformat.channels)
, 0); cs(lmsg);


/*if(0==strcmp(tag->key,"artist")) { snprintf(lmsg,1022,"Artist: %s\n",tag->value); cs(lmsg); }
  else if(0==strcmp(tag->key,"title")) { snprintf(lmsg,1022,"Title: %s\n",tag->value); cs(lmsg); }
  else if(0==strcmp(tag->key,"album")) { snprintf(lmsg,1022,"Album: %s\n",tag->value); cs(lmsg); }
  else if(0==strcmp(tag->key,"comment")) { snprintf(lmsg,1022,"Comment: %s\n",tag->value); cs(lmsg); }
  else if(0==strcmp(tag->key,"genre")) { snprintf(lmsg,1022,"Genre  : %s\n",tag->value); cs(lmsg); }
  else if(0==strcmp(tag->key,"date")) { snprintf(lmsg,1022,"Year: %s\n",tag->value); cs(lmsg); }

  else if(0==strcmp(tag->key,"StreamTitle")) { snprintf(lmsg,1022,"Title: %s\n",tag->value); cs(lmsg); }
  else if(0==strcmp(tag->key,"icy-genre")) { snprintf(lmsg,1022,"Genre  : %s\n",tag->value); cs(lmsg); }
  else if(0==strcmp(tag->key,"icy-name")) { snprintf(lmsg,1022,"Comment: %s\n",tag->value); cs(lmsg); }
snprintf(lmsg, 1022, "xmp_update_info: %s=%s", tag->key, tag->value); dlog(9,lmsg);
*/
}

/* int xmp_set_player(xmp_context c, int param, int val)
Set player parameter with the specified value.
Parameters:
 param:	player parameter to set. Valid parameters are:

 XMP_PLAYER_AMP      * Amplification factor *
 XMP_PLAYER_MIX      * Stereo mixing *
 XMP_PLAYER_INTERP   * Interpolation type *
 XMP_PLAYER_DSP      * DSP effect flags *
 XMP_PLAYER_FLAGS    * Player flags *
 XMP_PLAYER_CFLAGS   * Player flags for current module*
 XMP_PLAYER_SMPCTL   * Control sample loading *
 XMP_PLAYER_VOLUME   * Player master volume *
 XMP_PLAYER_DEFPAN   * Default pan separation *

 val:	the value to set. Valid values are:

 Amplification factor: ranges from 0 to 3. Default value is 1.
 Stereo mixing: percentual left/right channel separation. Default is 70.
 Interpolation type: can be one of the following values:
  XMP_INTERP_NEAREST  * Nearest neighbor *
  XMP_INTERP_LINEAR   * Linear (default) *
  XMP_INTERP_SPLINE   * Cubic spline *
 DSP effects flags: enable or disable DSP effects. Valid effects are:
  XMP_DSP_LOWPASS     * Lowpass filter effect *
  XMP_DSP_ALL         * All effects *
 Player flags: tweakable player parameters. Valid flags are:
  XMP_FLAGS_VBLANK    * Use vblank timing *
  XMP_FLAGS_FX9BUG    * Emulate Protracker 2.x FX9 bug *
  XMP_FLAGS_FIXLOOP   * Make sample loop value / 2 *
 Player flags for current module: same flags as above but after applying module-specific quirks
 (if any).
 Control sample load. Valid values are:
  XMP_SMPCTL_SKIP     * Don't load samples *
  Disabling sample loading when loading a module allows allows computation of module duration
  without decompressing and loading large sample data, and is useful when duration information is
  needed for a module that won't be played immediately.
 Set the player master volume, in a 0-100 scale.

 Returns:
  0 if parameter was correctly set, -XMP_ERROR_INVALID if parameter or values are out of the valid
  ranges, or -XMP_ERROR_STATE if the player is not in playing state.
*/

void xmp_play();
/////###############################
void xmp_load(char *input_filename0) { lfd("xmp_load:state",xmpstate);
 static char lmsg[4096]; lmsg[4095]=0;
 snprintf(lmsg, 4095, "Playing %s\n", input_filename0); cs(lmsg);

 if(input_filename0[0]==0) return;
 if(input_filename0[0]==*"\"" && input_filename0[1]==*"\"" && input_filename0[2]==0)
 { cs("EOF code: stop requested\n"); if(xmpstate>2) xmp_stop();
 return; }

 if(xmpstate==0) xmp_init();
 else if(xmpstate>2) xmp_stop();

 xmpstate=2; xmpcur=0; xmpdur=0;
 char *input_filename=input_filename0;


/*
struct xmp_test_info xmpti;
if(xmp_test_module(input_filename, &xmpti)!=0) { dlog(9,"xmp_test_module failed"); }
else {
 snprintf(lmsg,4095,"xmp: module name: %s", xmpti.name); dlog(9,lmsg);
 snprintf(lmsg,4095,"xmp: module type: %s", xmpti.type); dlog(9,lmsg);
}*/

 if(xmp_load_module(xmpc, input_filename)!=0)
 { dlog(9,"xmp_load failed");
 xmp_die("EOF code: xmp_load_module failed\n");
 return; }

 sfmt=AV_SAMPLE_FMT_S16;
      if(sfmt==AV_SAMPLE_FMT_U8 || sfmt==AV_SAMPLE_FMT_U8P){ sformat.bits=8; }
 else if(sfmt==AV_SAMPLE_FMT_S16 || sfmt==AV_SAMPLE_FMT_S16P){ sformat.bits=16; }
 else if(sfmt==AV_SAMPLE_FMT_S32 || sfmt==AV_SAMPLE_FMT_S32P){ sformat.bits=32; }
 else if(sfmt==AV_SAMPLE_FMT_FLT || sfmt==AV_SAMPLE_FMT_FLTP){ sformat.bits=32; }
 else if(sfmt==AV_SAMPLE_FMT_DBL || sfmt==AV_SAMPLE_FMT_DBLP){ sformat.bits=64; }
 else { xmp_die("EOF code: Unsupported format\n"); return; }

 sformat.channels=2; sformat.rate=44100;
#ifdef LAO
 sformat.byte_format=AO_FMT_NATIVE; sformat.matrix=0;
#endif

// xmpdur=t2/1000000.0; sprintf(lmsg, "ANS_length=%.1f\n", xmpdur); cs(lmsg);

 adev_setp(sformat.bits, &sformat.channels, &sformat.rate);

 xmp_update_info(input_filename);

 xmpstate=3; xmpi=1;
 xmp_play();
}
void oscp_xmp_check_input();
void oscp_xmp_parse(char *a);
/////################# check messages
void xmp_check_input() { lf("xmp_check_input"); static char lmsg[4096]; static int rc;
 static fd_set xmpfsa;  static struct timeval xmptv,*tvp;
 if(xmpstate==4) { tvp=NULL; }
 else { xmptv.tv_sec=0; xmptv.tv_usec=1; tvp=&xmptv; }

 FD_ZERO(&xmpfsa); if(parent_said>=0) FD_SET(parent_said, &xmpfsa);

 rc=select(FD_SETSIZE, &xmpfsa, NULL, NULL, tvp);
 if(rc==0){ if(tvp==NULL) dlog(9,"xmp_check_input: rc==0 when tvp==NULL"); return; }
 else if(rc<0) {
  dlog(9,"xmp_check_input: rc<0");
  sprintf(lmsg, "Info: xmpci rc<0, %d, %s\n", errno, strerror(errno)); cs(lmsg); }
 else if(rc>0) { // check if input is available
  //dlog(9,"xmp_check_input: rc>0");
  fdreadline(parent_said, lmsg, 1020); oscp_xmp_parse(lmsg); }
}
/////##################
void xmp_pause_toggle() { lf("xmp_pause_toggle");
      if(xmpstate==3) { xmpstate=4; cs("===== PAUSE =====\n");
  do { oscp_xmp_check_input(); } while(xmpstate==4);
 }
 else if(xmpstate==4) { xmpstate=3; cs("===== RESUME =====\n"); }
 else cs("Info: pause called but xmpstate != (3 || 4)"); }

/////#############
void xmp_checksd() {}
/////#############
void xmp_checkmd() {}
/////##########
void xmp_play() { lf("xmp_play"); dlog(9, "xmp_play");
 if(xmpstate!=3) { cs("EOF code: can't play, not inited\n"); return; }
 int t1=0,ot1=-1; xmpcur=0; xmpdur=0;
 static char lmsg[128];
 void *buf[1];

 xmp_start_player(xmpc, sformat.rate, 0);

 while(xmpstate==3 && xmp_play_frame(xmpc)==0)
 { xmp_get_frame_info(xmpc, &xmpfi); if(xmpfi.loop_count>0) break; // dont loop songs

  t1=xmpfi.time/1000; if(t1!=ot1)
  { ot1=t1; xmpcur=t1; sprintf(lmsg, "A: %.1f 0 0 0 0 0 0 0\n", xmpcur); cs(lmsg);
   if(xmpdur==0) { xmpdur=xmpfi.total_time/1000.0; sprintf(lmsg, "ANS_length=%.1f\n", xmpdur); cs(lmsg); }
  }

  buf[0]=xmpfi.buffer;
  adev_out(buf, xmpfi.buffer_size/4, 2, sfmt);

#if 0
if(0&&ot2==1) { // static char lmsg[1024]; sprintf(lmsg,
 "Info: fmt:%s, ch:%d, bi:%d, ra:%d, len:%d, plane_size: %d",
 lfmt, sformat.channels, sformat.bits, sformat.rate, len, plane_size); dlog(9,lmsg); }
#endif

  xmpi++; xmp_check_input();
 }
 

 adev_close();
 xmp_die("EOF code: finished decoding\n");
 lf("xmp_play:finished");
}

/////##########################
void oscp_xmp_load(char *fn) { lf("oscp_xmp_load");
 xmp_load(fn); //xmp_play();
 lf("oscp_xmp_load:finished");
}
/////####################
void oscp_xmp_seek(int a) { lf("oscp_xmp_seek");
 if(xmp_seek_time(xmpc, (xmpcur+a)*1000)<0) dlog(9,"oscp_xmp_seek: failed");
}
/////#######################
void oscp_xmp_parse(char *a) { lf("oscp_xmp_parse"); char lmsg[4096];
// sprintf(lmsg,"ofparse start"); dlog(9,lmsg);
 int l=strlen(a); if(l<=0) { sprintf(lmsg,"ofparse: l==%d ?", l); dlog(9,lmsg); return; }
 if(strcmp(a,"q")==0 || strcmp(a,"quit")==0) { xmp_end(); exit(0);
 } else if(strncmp(a,"loadfile ",9)==0) { oscp_xmp_load(a+9);
 } else if(strncmp(a,"load ",5)==0) { oscp_xmp_load(a+5);
 } else if(strncmp(a,"pause",5)==0) { xmp_pause_toggle();
 } else if(strncmp(a,"get_property length",19)==0) {
  sprintf(lmsg, "ANS_length=%.1f\n", xmpdur); cs(lmsg);
 } else if(strncmp(a,"get_property time_pos",19)==0 || strncmp(a,"get_time_pos",12)==0) {
//  sprintf(lmsg, "A: %.1f 0 0 0 0 0 0 0 0 0\n", xmpcur); cs(lmsg);
 } else if(strncmp(a,"seek ",5)==0) { int o1=0;
       if(a[5]==*"-") { sscanf(a+6, "%d", &o1); o1*=-1; }
  else if(a[5]==*"+") { sscanf(a+6, "%d", &o1); }
  else { sscanf(a+5, "%d", &o1); }
  oscp_xmp_seek(o1);
 } else if(strncmp(a,"vis ",4)==0) { sscanf(a+4, "%d", &vis);
 } else if(strncmp(a,"lfdump",5)==0) { lfdump();
 } else { sprintf(lmsg, "ofparse unhandled: %s", a); dlog(9, lmsg); }
 lf("oscp_xmp_parse:finished");
}
/////###################### check stdin
void oscp_xmp_check_input() { lf("oscp_xmp_check_input");
 char lmsg[4096]; int i, rc; fd_set fsa;
 struct timeval *tvp=NULL; //, tv; tv.tv_sec=0; tv.tv_usec=10000*99; // i=(int)time(NULL);
 usleep(10000); FD_ZERO(&fsa); if(parent_said>=0) FD_SET(parent_said, &fsa);
 rc=select(FD_SETSIZE, &fsa, NULL, NULL, tvp); // block till input

 if(rc<0) { if(0) { exit(EXIT_FAILURE); } else usleep(10000*99); }
 else if(rc==0) { }
 else for(i=0; i<FD_SETSIZE; ++i) if(FD_ISSET(i, &fsa)) {
  if(i==parent_said) { fdreadline(i, lmsg, 1020); oscp_xmp_parse(lmsg); }
 }
 lf("oscp_xmp_check_input:finished");
}
////##################
int oscp_xmp_main() { lf("oscp_xmp_main");
 cs("oscp-slave xmp "XMP_VERSION"\n");
 lf("oscp_xmp_main:xmp_init");
 xmp_init();
 lf("oscp_xmp_main:while");
 while(1) { oscp_xmp_check_input(); }
 lf("oscp_xmp_main:xmp_end");
 xmp_end();
 lf("oscp_xmp_main:finished");
 cs("EOF code: exit\n");
// lfdump();
 return 0;
}
