/*
 * oscp-utils.c
 * Copyright (C) 2015 KotCzarny <tjosko@yahoo.com>
 *
 *  This program is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the
 *  Free Software Foundation; either version 2 of the License, or (at your
 *  option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <dirent.h> //PATH_MAX
#include <sys/file.h> // flock

//## variables
extern int state, parent_said, parent_ear;

#define PM PATH_MAX

extern struct conf_s {
 int conf_ver,debug,quit,paused, lines,cols, lw,lh, lineart, offs, fullpath, vis,
  shuffle, repeat, eias, autoplay, autoalpha, timeremaining_mode, style[13];
 int lastpos; char wd[PM], file[PM], udir[10][PM], favsavepath[PM], mplayer_path[PM];
 char midi_patch_dir[PM], midi_patch_cfg[PM]; 
} conf;
struct conf_s conf;
/* = {
 8,0,0,0, 1,1, 1,1, 0, 0, 2, 0,
 0, 0, 0, 0, 0, 0, {},
 0, "", "", {"","","","","","","","","",""}, "",
#ifdef CYGWIN
 "./mplayer.exe"
#else
 "mplayer"
#endif
};*/

extern char clip_title[128], clip_artist[128], clip_genre[128], clip_album[128], clip_comment[128],
 clip_year[128]; extern int clip_subsong;

//#define LF 0
#ifndef LF
void lf(char *a) {}
void lf2(char *a, char *b) {}
void lfd(char *a, int b) {}
void lfdump() {}
#else
#define lfmax2 320 //max entries
#define lfmax 256 //max chars
char lfn[lfmax2][lfmax]; char lfl[lfmax]; int lfi=0, lft=0;
/////###########
void lf(char *a) { if(conf.debug>0 && strcmp(lfl, a)!=0) { strcpy(lfl, a);
  snprintf(lfn[lfi], lfmax-1, "%6d %s", lft, a); lfn[lfi][lfmax-1]=0;
  int i; for(i=0; i<lfmax && lfn[lfi][i]!=0; i++) { if(lfn[lfi][i]==*"\n") lfn[lfi][i]=*"N"; }
  lft++; lfi++; if(lfi>=lfmax2) lfi=0;
 }

// if(conf.debug>=10) { fseek(flog, 0, SEEK_END); fwrite("LF: ",4,1,flog);
//  fwrite(a,strlen(a),1,flog); fwrite("\n", 1,1,flog); fflush(flog); }
}
/////#####################
void lf2(char *a, char *b) { static char lmsg[lfmax-8]; snprintf(lmsg, lfmax-8, "%10s|%s", a, b);
 lmsg[lfmax-9]=0; lf(lmsg); }
/////###################
void lfd(char *a, int b) { static char lmsg[lfmax-8]; snprintf(lmsg, lfmax-8, "%10s|%d", a, b);
 lmsg[lfmax-9]=0; lf(lmsg); }
/////########
void lfdump() { int i; FILE *f=fopen("/tmp/oscp.lfdump","w");
 if(f) { fprintf(f, "---lfdump_start---\n[lft: %d, lfi: %d]\n", lft, lfi);
  for(i=0;i<lfmax2;i++) { fprintf(f, "[%s]\n", lfn[i]); }
  fprintf(f,"---lfdump_end---\n"); fclose(f);
 }
}
#endif


FILE *flog; int d00;
/////######################
void dlog(int l, char *msg) {
#ifdef DLOG
 lf2("dlog", msg);  if(!flog) return; if(l>conf.debug) return; static char lbuf[4096];
 snprintf(lbuf, 4095, "[%d %d %d %s]\n", (int)time(NULL)-d00, l, state, msg); lbuf[4095]=0;
/*  int flock(int fd, int operation);
 LOCK_SH  Place a shared lock.  More than one process may hold a shared lock for a given file at a
   given time.
 LOCK_EX  Place an exclusive lock.  Only one process may hold an exclusive lock for a given file
   at a given time.
 LOCK_UN  Remove an existing lock held by this process.
*/
#ifndef CYGWIN
 flock(fileno(flog), LOCK_EX);
#endif
 fseek(flog, 0, SEEK_END); fwrite(lbuf, strlen(lbuf), 1, flog); fflush(flog);
#ifndef CYGWIN
 flock(fileno(flog), LOCK_UN);
#endif
#endif
}
/////###########
void dlog_init() { lf("dlog_init"); d00=(int)time(NULL);
 if(conf.debug>0) flog=fopen("/tmp/oscp.log", "w"); else flog=0; 
 dlog(9,"dlog_init");
}
void dd(int l, char *msg, int i);
void ds(int l, char *msg, char *m2);

/////############################
void namC2W(char *dst, char *src) {
#ifdef CYGWIN
 lf2("namC2W",src); int id=0, is=0, i;
 dlog(9, "namC2W");
 char root[4096], a[4096], *a1; FILE *f=fopen("/proc/mounts","r");
 if(!f) dlog(8, "namC2W: can't open /proc/mounts");
 i=0; while(fgets(a, 4095, f)>0) { a1=strstr(a, " / "); if(a1==NULL) continue;
  i=a1-a; if(i<=0) continue;
  strncpy(root, a, i); root[i]=0;
  dlog(9, "root:"); dlog(9, root); break;
 } if(i<=0) dlog(9, "root find failed");

 if(strcmp(src, "/cygdrive/")==0)
 { is=10; strncpy(dst, src+is, 1); id++; is++; strcat(dst+id, ":\\"); id+=2; }
 else if(src[0]==*"/") { strcpy(dst, root); id+=strlen(root); }
 strcat(dst+id, src+is);
 for(i=0; i<=strlen(dst); i++) { if(dst[i]==*"/") dst[i]=*"\\"; }

 dlog(9,src); dlog(9,dst);
#endif
}
/////##########################################################
void normalize_path(char *dst, const char *src, size_t src_len) {
 lf2("normalize_path", dst);
 if(src[0]==0) { dst[0]=0; return; }
 char *tmp; strcpy(dst, src);
 tmp=rindex(dst, *"/"); if(tmp) {
  if(strcmp("/..", tmp)==0) { dst[tmp-dst]=0;
   tmp=rindex(dst, *"/"); if(tmp) { if(tmp==dst) dst[1]=0; else dst[tmp-dst]=0; }
 } } // printf("[np: %s -> %s (%d)]\n", src, dst, tmp-src); d(0,dst); refresh(); usleep(3000000);
}
#if 1
///////######################
char * get_basename(char *fn) { lf2("get_basename", fn); char *p=fn+strlen(fn); int a=0;
 while(p>=fn) { --p; if(p[0]!=*"/") a++; else if(a>0) { break; } }
 if(p[0]!=0) ++p;
 if(p[0]!=0 && strncmp(p, "oscptmp-", 8)==0) p+=8;
 return p; }
#else
char * get_basename(char *fn) { lf2("get_basename", fn); char *p=rindex(fn, *"/");
 if(!p) p=fn; else { p++; if(strncmp(p,"oscptmp-",8)==0) p+=8; } return p; }
#endif
///////#################
char * get_bn2(char *fn) { lf2("get_bn2", fn); char *p=rindex(fn, *"/"); if(!p) p=fn; else
 { while(--p>fn && p[0]!=*"/") {} p++; } return p; }
////######################
int get_filesize(char *fn) { lf2("get_filesize", fn);
 int fs=0;
 FILE *f=fopen(fn, "r"); if(!f) return -1;
 if(fseek(f, 0, SEEK_END)==0) fs=ftell(f); else fs=-2;
 fclose(f); return fs;
}
/////##################################
void fdreadline(int fd, char *b, int n) { lf("fdreadline"); // char lmsg[4096];
 int i=0; do { if(read(fd, b+i, 1)<=0 || b[i]==*"\n") { b[i]=0; i=n; }
//  else { sprintf(lmsg, "fdrl: %d,%d,%c", i,b[i],b[i]); dlog(9,lmsg); }
  i++;
 } while(i<n); if(i>=n) b[n]=0;
// sprintf(lmsg, "fdreadline: %d,%d,%d,%s", fd, i, n, b); dlog(9, lmsg);
}
/////########### child: send(say to parent), recv(hear)
void cs(char *a) { lf2("cs",a); if(parent_ear>=0) {
 int i,l=strlen(a); if(l<=1) { dlog(9,"ERR: cs, l<=1"); return; }
  if(l>4095) { dlog(9,"ERR: cs, l>4095"); return; }
  int ii=0;
  for(i=0;i<l-1;i++) { if(a[i]==*"\n") { ii++; a[i]=*" "; if(ii==0) dlog(9,"ERR: cs, \\n in the middle"); } }
  if(ii>0) dlog(9,a);
  write(parent_ear, a, strlen(a));
 }
}
/////##################
void cr(char *b, int n) { lf("cr"); fdreadline(parent_said, b, n); }
/////##########
char r(float c) { lf("r"); if(rand()<=c*RAND_MAX) return 1; else return 0; }

// struct timespec pts0,pts1;
//////############################################ diff times
float dts(struct timespec ts, struct timespec ts0) { lf("dts"); int ds; long int dn;
 if(ts0.tv_nsec > ts.tv_nsec) { ds=0; dn=0; } else { ds=1; dn=1000000000L; }
 return ts.tv_sec-ds-ts0.tv_sec + (ts.tv_nsec+dn-ts0.tv_nsec)*0.000000001;
}
//////######################### get timestamp
float gts(struct timespec *tss) { lf("gts"); clock_gettime(CLOCK_REALTIME, tss);
 return (1.0*tss->tv_sec + 0.000000001*tss->tv_nsec);
}
///////#################
char * get_conf(char *a) {
      if(0==strcmp(a, "midi_patch_dir")) return conf.midi_patch_dir;
 else if(0==strcmp(a, "midi_patch_cfg")) return conf.midi_patch_cfg;
 else return NULL;
}
/////###########################
void set_confS(char *a, char *b) {
      if(0==strcmp(a, "midi_patch_dir")) strncpy(conf.midi_patch_dir,b,PM-1);
 else if(0==strcmp(a, "midi_patch_cfg")) strncpy(conf.midi_patch_cfg,b,PM-1);
}

///////###################
char * trimleft(char *str) { lf("trimleft");
 int c; while((str[0]==' ' || str[0]=='\t') && str[0] != '\0')
 { c = 0; do { str[c] = str[c+1]; } while (str[++c] != '\0'); } return str; }
///////####################
char * trimright(char *str) { lf("trimright");
 char *s = str + strlen(str) - 1;
 while (s>=str && (*s==' ' || *s=='\t')) *s-- = '\0'; return str; }
///////###############
char * trim(char *str) { lf("trim"); return trimleft(trimright(str)); }

////######################
int rr(int rmin, int rmax) { lf("rr"); return rand()/(RAND_MAX/(rmax-rmin+1))+rmin; }

////#######################
int id3f7(unsigned char *b) { lf("id3f7"); return (b[0]<<0); }
int id3f14(unsigned char *b) { lf("id3f14"); return (b[0]<<7)+(b[1]<<0); }
int id3f21(unsigned char *b) { lf("id3f21"); return (b[0]<<14)+(b[1]<<7)+(b[2]<<0); }
int id3f28(unsigned char *b) { lf("id3f28"); return (b[0]<<21)+(b[1]<<14)+(b[2]<<7)+(b[3]<<0); }
int id3f32(unsigned char *b) { lf("id3f32"); return (b[0]<<24)+(b[1]<<16)+(b[2]<<8)+(b[3]<<0); }
////###############################
int id3t32(unsigned char *b, int s) { lf("id3t32"); int a=0,d=1; char lmsg[1024]; lmsg[0]=0;
 switch(s) {
  case 4: a=id3f28(b); if(d)sprintf(lmsg, "[id3t28 | %d | %02x %02x %02x %02x]", a, b[0], b[1],
 b[2], b[3]); break;
  case 3: a=id3f21(b); if(d)sprintf(lmsg, "[id3f21 | %d | %02x %02x %02x]", a, b[0], b[1], b[2]);
 break;
  case 2: a=id3f14(b); if(d)sprintf(lmsg, "[id3f14 | %d | %02x %02x]", a, b[0], b[1]); break;
  case 1: a=id3f7(b);  if(d)sprintf(lmsg, "[id3f7 | %d | %02x]", a, b[0]); break;  }
 if(d && lmsg[0]!=0) ds(10, "id3t32", lmsg);
 return a;}
/////########################################################
void get_id3string(char *t, unsigned char *b, int tl, int te) { lf("get_id3string");
 int i; bzero(t, 4096);
 if(te!=1) { memcpy(t, b, tl); }
 if(te==1) { int o; if(b[0]==0xff && b[1]==0xfe) o=0; else if(b[0]==0xfe && b[1]==0xff) o=1;
  else { if(0)printf("[bad encoding?]"); return; }
  for(i=2; i<tl; i+=2) if(b[i+1-o]==0) { t[i/2-1]=b[i+o]; }
 } for(i=0; i<tl/2-1; i++) if(t[i]==0) t[i]=0x20; }
/////###################
void get_id3v2(char *fn) { lf("get_id3v2"); FILE *f=fopen(fn, "r"); if(!f) return;
 int d=(conf.debug>=10?1:0), i=0, s, c, ttl=0, tag, tl, te; char lmsg[64], buf[4096], tbuf[4096];
 unsigned char *ubuf, *u2;  fread(buf, 4095, 1, f); buf[4095]=0; fclose(f);
//00000000 49 44 33 04 | 00 00 00 00 | 00 16 54 45 | 4E 43 00 00 | 00 0C 00 00  ID3.......TENC......
//00000014 03 4C 61 76 | 66 35 32 2E | 33 31 2E 30 | FF FB 90 44 | 00 00 02 79  .Lavf52.31.0.D...y
//00000028 47 3C 05 04 | 40 02 4A 43 | 07 20 A0 88 | 00 0D 05 97 | 4E B8 55 00  G<..@.JC. .....NU.
 s=3; if(strncmp(buf, "ID3", s)!=0) return; ubuf=(unsigned char *)buf;
 i+=s; ubuf+=s; s=3; id3t32(ubuf,s);
 i+=s; ubuf+=s; s=4; ttl=id3t32(ubuf, s); if(d){sprintf(lmsg,"[%s, ttl:%d]", fn, ttl);
  dd(10,"id3v2, ttl", ttl);}
 do { i+=s; ubuf+=s; s=4;
//sprintf(lmsg, "i: %d, s
dd(10, "id3v2, i", i);
  c=(ubuf[0]==0||ubuf[1]==0||ubuf[2]==0||ubuf[3]==0?0:1);
  if(c>0) {
  if(d)printf("\n[subtag @%4d]", i); tag=id3t32(ubuf, s);
   if(d)printf("[%x,%c%c%c%c]", tag, ubuf[0], ubuf[1], ubuf[2], ubuf[3]);
  i+=s; ubuf+=s; s=4; tl=(id3t32(ubuf, s)-1); if(d)printf("[tl:%2d]", tl);
  // fix for bugged length (not 7bit)
  if(i+s+3+tl<4096-8) { u2=ubuf+s+3+tl; } else u2=NULL;
   if(u2==NULL ||u2[0]==0||u2[1]==0||u2[2]==0||u2[3]==0) { tl=(id3f32(ubuf)-1);
   if(d)printf("[tl2:%2d]", tl); }
  if(i+s+3+tl>4096-4) { break; }
  i+=s; ubuf+=s; s=3; te=id3t32(ubuf, s); if(d)printf("[te:%d]", te);
  i+=s; ubuf+=s; s=tl;
  // a9422b1,TPE1 a926a32,TIT2 a906642,TALB a9662d2,TYER a94a1cb,TRCK a90a84d,TBPM a90e7ce,TCON
  if(i+tl<4096 &&
   (tag==0xa926a32 || tag==0xa9422b1 || tag==0xa906642 || tag==0xa9662d2 || tag==0xa90e7ce))
  { get_id3string(tbuf, ubuf, tl, te); if(d)printf("[string:%s]", tbuf); switch(tag) {
   case 0xa9422b1: strncpy(clip_artist, tbuf, 126); break;
   case 0xa926a32: strncpy(clip_title, tbuf, 126); break;
   case 0xa906642: strncpy(clip_album, tbuf, 126); break;
   case 0xa9662d2: strncpy(clip_year, tbuf, 126); break;
   case 0xa90e7ce: strncpy(clip_genre, tbuf, 126); break;
  }}
 }} while(c>0 && i<4096-16 && (s>0 && i+s<ttl)); if(d)printf("\n");
}

