/*
 * oscp.c
 * Copyright (C) 2015 KotCzarny <tjosko@yahoo.com>
 *
 *  This program is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the
 *  Free Software Foundation; either version 2 of the License, or (at your
 *  option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#define VERSION "0.9.6"

#include "oscp-utils.h"
//int printf(const char *format, ...);

void ffm_show_supp(); void xmp_show_supp(); void fc14_show_supp(); void asap_show_supp();
void sc68_show_supp(); void sid2_show_supp(); void gme_show_supp(); void mdx_show_supp();
void timi_show_supp();

int oscp_ffmpeg_main(); int oscp_xmp_main(); int oscp_asap_main(); int oscp_sc68_main();
int oscp_fc14_main(); int oscp_sid2_main(); int oscp_gme_main(); int oscp_mdx_main();
int oscp_timi_main();


char tn[24][8]={"U0","UADE2","LAV","TIM","XMP","SP2","SPC","NSF","FC","GME","U10","U11","H-LAV"
  ,"U13","U14","U15","SAP","SC68","MDX","U19","U20","U21","U22",""};


/////##############
void show_formats() {
 ffm_show_supp(); xmp_show_supp(); fc14_show_supp(); gme_show_supp(); asap_show_supp();
 sc68_show_supp(); sid2_show_supp();
 mdx_show_supp();
 timi_show_supp();
 printf("  [slave-uade2]: external");
 printf(", formats: adsc, abk, ac1d, ahx, alp, amc, aon, aon8, ast, avp, bp, bp3"
 ", bpsm, bd, bds, bss, chan, cin, cm, core, cust, cus, dat, dh, di, dl, dlm1, dlm2"
 ", dln, dm1, dm2, dns, doda, dsc, dsr, dum, dmu, dss, dw, dz, ea, ems, emsv6, eu"
 ", ex, fc, fc13, fc14, fc3, fc4, fcm, fp, fred, fw, glue, gray, hd, hip, hip7, hipc"
 ", hn, ims, is, is20, jam, jcb, jcbo, jd, jmf, jo, jpn, jpnd, jpo, jpold, kh, kris"
 ", ksm, lax, ma, mc, mcmd, mco, mcr, mcs, md, mdat, mdst, mii, midi, mk2, mkii, ml"
 ", mmdc, mok, mon, mso, mtp2, mug, mug2, mw, pap, pc, psa, psf, pt, puma, pvp, qpa"
 ", qts, rh, rk, s, s7g, sa, sc, sct, scumm, sdata, sfx, sfx13, sid1, sid2, sidmon"
 ", sjs, sm, smus, sng, snx, soc, sog, sonic, spl, sqt, src, sun, syn, synmod, tf"
 ", tfmx, tfx, thm, thx, tiny, tme, tronic, uds, unic, vss, wb, ym");
 printf("\n");
}

/////#########################################
void show_help(char *progname, char *confname) { lf("show_help");
 printf("\
oscp by ariel/KotCzarny v%s build: %s\n\
oscp.c md5: %s\n\
\n\
 tiny media player/frontend:\n\
 - libav (mp3, wav, ogg, aac, mpc, wma, flac, ape, etc)\n\
 - wildmidi or timidity++ (mid)\n\
 - xmp (mod, med, xm, s3m, it, dbm, psm, omx, okt, digi, 669, mtm, acid, umx)\n\
 - gme (ay, gbs, gym, hes, kss, nsf, nsfe, sap, spc, vgm)\n\
 - sidplay2 (sid, psid, info)\n\
 - mdxplay (mdx)\n\
 - fc14dec (fc, fc13, fc14)\n\
 - sc68 (sc68, sndh)\n\
 - asapconv (sap, cmc, cm3, cmr, cms, dmc, dlt, mpt, mpd, rmt, tmc, tm8, tm2)\n\
 - uade (fc, bp, ay, dl, tfmx, hip, mon, sa, ahx, aon, cust, and many more..)\n\
\n\
 feats:\n\
 - small and fast\n\
 - remembers playlist position\n\
 - unzip/unrar support\n\
 - ncurses ui with easy navigation\n\
 - lirc (remote) support\n\
\n\
config: %s\n\
\n\
 actions: -18 up, -12 down, -19 pgup, -13 pgdn, -17 home, -11 end, \n\
  -14 home+enter, -16 enter, -21 copy_to_fav, p pause, [ prev, ] next,\n\
  \" \" next, \",\" rwnd, . ffwd, e eias, s shuffle, r repeat, t timeremaining,\n\
  f fullpath, i info, ; make_recursive_list, - chvol(-), = chvol(+), \\ stop,\n\
  q quit, 0-9 load_dir_or_vdir(0-9)\n\
\n\
 remote assigns: key_:\n\
  power q, up -18, down -12, channelup -19, channeldown -13, left -14,\n\
  right -16, ok -16, previous [, next ], blue [, green ], # shuffle,\n\
  * repeat, rewind ,, fastforward ., red ,, yellow ., volumedown -, volumeup =,\n\
  play -16, pause p, stop \\, text say_title, 0-9 0-9\n\
\n\
usage: %s [options] [path]\n\
	-a <0/1>	autoplay off/on\n\
	-s <0/1/2>	shuffle mode\n\
	-r <0/1>	repeat off/on\n\
	-t <0/1>	display remaining time instead of current\n\
	-f <0/1/2>	fullpath display\n\
	-V <0/1>	vis off/on (buggy for now)\n\
	-d <0..10>	debug\n\
	-l <0/1>	use lineart compatible/full\n\
	-F <string>	fav save path\n\
	-M <string>	midi sound patch directory\n\
	-m <string>	midi sound patch config\n\
	-H		show supported formats\n\
	-h		this help (duh)\n\
", VERSION, BUILD, MD5, confname, progname);
}

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <dirent.h>
#include <libgen.h> // basename
#include <sys/stat.h> // stat
#include <sys/file.h> // flock
#include <unistd.h>
#include <time.h>
#include <signal.h> //sigaction

#include <sys/time.h>
#include <sys/resource.h>
#include <sys/socket.h>

#define bufsizee 40960
char buf[bufsizee], buf_tmp[bufsizee], *param_list[14][32];
char conf_name[PM];

int slave_s(char *msg);

void mixer_end(); int get_volume(); void set_volume(); void chvol(int ch); void mixer_init();

int vis;
int state=0,freq=0,chan=0,bitrate=0;
int elapsedtime=0, remainingtime=0, totaltime=0, last_totaltime=0, ilu=0;
char listname[PM], vfstmpname[PM];

char clip_title[128], clip_artist[128], clip_genre[128], clip_album[128], clip_comment[128],
 clip_year[128]; int clip_subsong=0;


void load_dir(char *dir_name);
void draw_list();

int last_type=-77;
pid_t slave_pid=-1; int slave_send, slave_recv, slave_recv2, buflen;

int parent_said, parent_ear, vis;

struct list_el { char *v, *v1, *v2; int a0; int a1; int a2; struct list_el *next;
 struct list_el *prev;
 struct list_el *nextS;
 struct list_el *prevS;
}; typedef struct list_el bli;

// d_head: v - path/file, v1 = rindex(v, *"/"), v2=rindex(v1, *"/"),
// a0 - , a1 - 0-shown, 1-hidden, a2 - type

bli *d_head, *d_tail; int dmt=0;
bli *f_head, *f_tail, *f_head2; int fmt=0, fmt2=0;
bli *f_headS, *f_tailS;
#define MAXPLAYLIST 65536*4
bli *d_i[MAXPLAYLIST]; // index
bli *t_i[MAXPLAYLIST]; // temporary index

int cur=0,pos=0,top=0;

// **top because we need to modify it
/////################################################## insert unsorted (but filo)
//void baddu(bli **top, int a0, int a1, int a2, void *v) { bli *c; c=(bli *) malloc(sizeof(bli));
// c->a0=a0; c->a1=a1; c->a2=a2; c->v=v; c->v1=NULL; c->v2=NULL; c->prev=NULL; c->next=*top; *top=c; }
/////############################################################# insert unsorted (fifo)
bli *baddu(bli **head, bli **tail, int a0, int a1, int a2, void *v) { lf("baddu"); bli *c;
 c=(bli *) malloc(sizeof(bli)); c->a0=a0; c->a1=a1; c->a2=a2; c->v=v; c->v1=NULL; c->v2=NULL;
 c->next=NULL; c->prev=NULL; if(*head==NULL) *head=c;
 if(*tail) { (*tail)->next=c; c->prev=*tail; } *tail=c;
 return c;
}

int ext2type(char *ext);
/////############################################# insert unsorted
bli *baddU(int a0, int a1, int type, char *d_path) { lf("baddU"); char *v, *ext; bli *c; int i;
 if(type==0) { ext=rindex(d_path, *"."); if(ext) type=ext2type(ext+1);
  if(type==0) { char *t1, *t2=NULL, prfx[8]; //, tmsg[128];
  t1=rindex(d_path, *"/"); if(t1) t2=index(t1, *".");
  if(t1 && t2 && t2-t1<8) { memcpy(prfx, t1+1, t2-t1-1); prfx[t2-t1-1]=0; type=ext2type(prfx); }
 } } //char tt[1024]; sprintf(tt, "baddD: type: %d", type); dlog(0,tt);

 if(type==12) { // handle http* entries
  int l=strlen(d_path); v=malloc(l+1); strcpy(v, d_path);
  fmt++; c=baddu(&f_head, &f_tail, 0, fmt, type, v); c->v1=c->v; c->v2=c->v; return c;
 }

 if(type!=-9 && (type!=0 || conf.eias)) { //  if(access(tmp, R_OK))
  v=malloc(strlen(d_path)+1); strcpy(v, d_path);
  if(type>=0) { fmt++; if(conf.eias!=0&&type==0) type=1; c=baddu(&f_head, &f_tail, 0, fmt, type, v); }
  else { dmt++; c=baddu(&d_head, &d_tail, 0, dmt, type, v); }

  // find filename and dirname/filename
  c->v1=1+rindex(c->v, *"/"); if(!c->v1) { c->v1=c->v; c->v2=c->v;}
  else { i=2; while((c->v)<(c->v1-i) && c->v1[-i]!=*"/")
   { i++; if(0) printf("[%c]", c->v1[-i]); }  c->v2=c->v1-i+1; }
  return c;
 }
 else return NULL;
}

/////#############################
void bprevs(bli **top, bli **tail) { lf("bprevs");
 bli *c, *c0=NULL; // update ->prev and _tail
 int i=0;
 c=*top; while(c) { if(c0) c->prev=c0;
  c->a1=++i;
  if(c->prev) c->prevS=c->prev;
  if(c->next) c->nextS=c->next;
  c0=c; c=c->next;
 } *tail=c0;

}
/////############################
void blist(bli *top, int verbose) { lf("blist"); char tt[1024];
 bli *c=top; int i=0;
 while(c) { i++;
if(conf.debug!=77) {
  sprintf(tt,"i:%d, a0:%d, a1:%d, a2:%d, v:%s", i, c->a0, c->a1, c->a2, (verbose>=1?c->v:"x"));
  dlog(0,tt);
} else {
  sprintf(tt,"i:%d, a1:%d, a1p:%d, a1n:%d, v:%s", i, c->a1,
   (c->prevS?c->prevS->a1:-7), (c->nextS?c->nextS->a1:-7), (verbose>=1?c->v:"x"));
  dlog(0,tt);
}
 if(verbose>=2) { sprintf(tt,"v1:%s", c->v1); dlog(0,tt); }
 if(verbose>=3) { sprintf(tt,"v2:%s", c->v2); dlog(0,tt); }
 c=c->next; }}
/////#############################
void bfree(bli **head, bli **tail) { lf("bfree"); bli *t, *c=*head;
 while(c) { t=c; c=c->next; t->next=NULL; if((t->v)!=NULL)free(t->v); if(t)free(t); } *head=NULL;
 *tail=NULL;
}
/////#########
void free_df() { lf("free_df"); bfree(&d_head,&d_tail); bfree(&f_head,&f_tail); dmt=fmt=0; }



#include <ncurses.h>


char dmsg[1024];
/////###################
void d(int l, char *msg) { lf2("d", msg); if(conf.debug<l) return; //bitset(&conf.dirty,1);
// gts(&pts1);
// printf("\033[2K[%.3f, %s]\n",dts(pts1, pts0), msg); /* if(l>=0) x_showinfo(msg); */ 
// mvaddstr(conf.lines-3,5,msg); refresh();

// for(i=0; i<strlen(filename); i++){ c=filename[i];
//   if ((c<32) || (c>=128 && c<160)) filename[i]=*"?";
//  } draw_filename(); refresh();
 mvaddnstr(conf.lines-3, 5, msg, conf.cols-7);
 int c; for(c=strlen(msg); c<conf.cols-7; c++)
  mvaddch(conf.lines-3, 5+c, ' '|COLOR_PAIR(4)|conf.style[4]);
  mvchgat(conf.lines-3, 5, conf.cols-7, conf.style[4], 4, NULL);
 refresh();
 dlog(l,msg);
}
/////###############
//void draw(char *msg) { int c=strlen(msg), y=conf.lines-4; mvaddnstr(y, 5, msg, conf.cols-7); refresh(); }
/////###########################
void dd(int l, char *msg, int i) { lf("dd"); sprintf(dmsg,"[%s: %d]",msg,i); d(l,dmsg); }
/////##############################
void ds(int l, char *msg, char *m2) { lf("ds"); sprintf(dmsg,"[%s: %s]",msg,m2); d(l,dmsg); }

/////###########
void save_conf() { lf("save_conf");
 char lbuf[PM+128]; FILE *f=fopen(conf_name,"w");
 if(!f){ printf("save_conf: can't open for writing (%s)\n",conf_name); return; }
// sprintf(lbuf, "conf_ver=%d\n", conf.conf.ver); fwrite(lbuf, strlen(lbuf), 1, f);
 sprintf(lbuf, "debug=%d\n",	conf.debug); fwrite(lbuf, strlen(lbuf), 1, f);
// sprintf(lbuf, "quit=%d\n",	conf.quit); fwrite(lbuf, strlen(lbuf), 1, f);
// sprintf(lbuf, "paused=%d\n",	conf.paused); fwrite(lbuf, strlen(lbuf), 1, f);
//  sprintf(lbuf, "lines=%d\n",	conf.linex); fwrite(lbuf, strlen(lbuf), 1, f);
//  sprintf(lbuf, "cols=%d\n",	conf.cols); fwrite(lbuf, strlen(lbuf), 1, f);
//  sprintf(lbuf, "lw=%d\n",	conf.lw); fwrite(lbuf, strlen(lbuf), 1, f);
//  sprintf(lbuf, "lh=%d\n",	conf.lh); fwrite(lbuf, strlen(lbuf), 1, f);
 sprintf(lbuf, "lineart=%d\n",	conf.lineart); fwrite(lbuf, strlen(lbuf), 1, f);
 sprintf(lbuf, "offs=%d\n",	conf.offs); fwrite(lbuf, strlen(lbuf), 1, f);
 sprintf(lbuf, "fullpath=%d\n",	conf.fullpath); fwrite(lbuf, strlen(lbuf), 1, f);
 sprintf(lbuf, "vis=%d\n",	conf.vis); fwrite(lbuf, strlen(lbuf), 1, f);
 sprintf(lbuf, "shuffle=%d\n",	conf.shuffle); fwrite(lbuf, strlen(lbuf), 1, f);
 sprintf(lbuf, "repeat=%d\n",	conf.repeat); fwrite(lbuf, strlen(lbuf), 1, f);
 sprintf(lbuf, "eias=%d\n",	conf.eias); fwrite(lbuf, strlen(lbuf), 1, f);
 sprintf(lbuf, "autoplay=%d\n", conf.autoplay); fwrite(lbuf, strlen(lbuf), 1, f);
//  sprintf(lbuf, "autoalpha=%d\n", conf.autoalpha); fwrite(lbuf, strlen(lbuf), 1, f);
 sprintf(lbuf, "timeremaining_mode=%d\n", conf.timeremaining_mode); fwrite(lbuf, strlen(lbuf), 1, f);
// sprintf(lbuf, "style0=%d")
 sprintf(lbuf, "mplayer_path=%s\n", conf.mplayer_path); fwrite(lbuf, strlen(lbuf), 1, f);
 sprintf(lbuf, "lastpos=%d\n",	conf.lastpos); fwrite(lbuf, strlen(lbuf), 1, f);
 sprintf(lbuf, "wd=%s\n",	conf.wd); fwrite(lbuf, strlen(lbuf), 1, f);
 sprintf(lbuf, "file=%s\n",	conf.file); fwrite(lbuf, strlen(lbuf), 1, f);
 sprintf(lbuf, "favsavepath=%s\n",	conf.favsavepath); fwrite(lbuf, strlen(lbuf), 1, f);
 sprintf(lbuf, "midi_patch_dir=%s\n",	conf.midi_patch_dir); fwrite(lbuf, strlen(lbuf), 1, f);
 sprintf(lbuf, "midi_patch_cfg=%s\n",	conf.midi_patch_cfg); fwrite(lbuf, strlen(lbuf), 1, f);

 int i; for(i=0; i<=9; i++) {
  sprintf(lbuf, "dir%d=%s\n",	i, conf.udir[i]); fwrite(lbuf, strlen(lbuf), 1, f);
 }

 fclose(f);
}
////################################
int load_conf(int argc, char **argv) { lf("load_conf"); int i; //char argpath[PM]; argpath[0]=0;
 dd(9, "load_conf", argc);

 sprintf(conf_name, "%s/.oscp.conf", getenv("HOME")); char lbuf[PM+128], *c1, *c2;

 // initialize paths for 0-9 keys
 for(i=0;i<=9;i++) { sprintf(conf.udir[i], "%s/fav-%d.m3u", getenv("HOME"), i); }

 FILE *f=fopen(conf_name,"r");
 if(!f){ printf("load_conf: can't open for reading (%s)\n",conf_name); }
 else {
  while(feof(f)==0 && fgets(lbuf, PM+127, f)!=NULL && lbuf[0]!=*"#") {
   lbuf[PATH_MAX+126]=*"\n"; lbuf[PM+127]=0;
   c1=strtok(lbuf, "="); if(c1) c2=strtok(NULL, "=\n"); else c2=NULL; if(c2) {
         if(strcmp(lbuf,"debug")==0)	{ conf.debug=atoi(c2); }
    else if(strcmp(lbuf,"lineart")==0)	{ conf.lineart=atoi(c2); }
    else if(strcmp(lbuf,"offs")==0)	{ conf.offs=atoi(c2); }
    else if(strcmp(lbuf,"fullpath")==0)	{ conf.fullpath=atoi(c2); }
    else if(strcmp(lbuf,"vis")==0)	{ conf.vis=atoi(c2); }
    else if(strcmp(lbuf,"shuffle")==0)	{ conf.shuffle=atoi(c2); }
    else if(strcmp(lbuf,"repeat")==0)	{ conf.repeat=atoi(c2); }
    else if(strcmp(lbuf,"eias")==0)	{ conf.eias=atoi(c2); }
    else if(strcmp(lbuf,"autoplay")==0)	{ conf.autoplay=atoi(c2); }
    else if(strcmp(lbuf,"timeremaining_mode")==0) { conf.timeremaining_mode=atoi(c2); }
    else if(strcmp(lbuf,"mplayer_path")==0)	{ strcpy(conf.mplayer_path,c2); }
    else if(strcmp(lbuf,"lastpos")==0)	{ conf.lastpos=atoi(c2); }
    else if(strcmp(lbuf,"wd")==0)	{ strcpy(conf.wd,c2); }
    else if(strcmp(lbuf,"file")==0)	{ strcpy(conf.file,c2); }
    else if(strcmp(lbuf,"favsavepath")==0)	{ strcpy(conf.favsavepath,c2); }
    else if(strcmp(lbuf,"midi_patch_dir")==0)	{ strcpy(conf.midi_patch_dir,c2); }
    else if(strcmp(lbuf,"midi_patch_cfg")==0)	{ strcpy(conf.midi_patch_cfg,c2); }
    else if(strcmp(lbuf,"dir0")==0 && strlen(c2)>0)	{ strcpy(conf.udir[0],c2); }
    else if(strcmp(lbuf,"dir1")==0 && strlen(c2)>0)	{ strcpy(conf.udir[1],c2); }
    else if(strcmp(lbuf,"dir2")==0 && strlen(c2)>0)	{ strcpy(conf.udir[2],c2); }
    else if(strcmp(lbuf,"dir3")==0 && strlen(c2)>0)	{ strcpy(conf.udir[3],c2); }
    else if(strcmp(lbuf,"dir4")==0 && strlen(c2)>0)	{ strcpy(conf.udir[4],c2); }
    else if(strcmp(lbuf,"dir5")==0 && strlen(c2)>0)	{ strcpy(conf.udir[5],c2); }
    else if(strcmp(lbuf,"dir6")==0 && strlen(c2)>0)	{ strcpy(conf.udir[6],c2); }
    else if(strcmp(lbuf,"dir7")==0 && strlen(c2)>0)	{ strcpy(conf.udir[7],c2); }
    else if(strcmp(lbuf,"dir8")==0 && strlen(c2)>0)	{ strcpy(conf.udir[8],c2); }
    else if(strcmp(lbuf,"dir9")==0 && strlen(c2)>0)	{ strcpy(conf.udir[9],c2); }
   }
  }
  conf.quit=0; conf.paused=0; // conf.benchmark=0; conf.dirty=0;
 }

//printf("argc: %d\n", argc);
/*
1 [0]./oscp
2.[0]./oscp [1]21 [2]2
3 [0]./oscp [1]21 [2]2
*/

 int argpath_i=0; char argpath[PM]; argpath[0]=0; // && strlen(argv[i])>1
 for(i=1;i<argc;i++) if(argv[i][0]==*"-") switch(argv[i][1]) {
   case 'a': i++; if(i<argc) conf.autoplay=atoi(argv[i]); break;
   case 's': i++; if(i<argc) conf.shuffle=atoi(argv[i]); break;
   case 'r': i++; if(i<argc) conf.repeat=atoi(argv[i]); break;
   case 't': i++; if(i<argc) conf.timeremaining_mode=atoi(argv[i]); break;
//   case 'a': i++; if(i<argc) conf.autoalpha=atoi(argv[i]); break;
   case 'f': i++; if(i<argc) conf.fullpath=atoi(argv[i]); break;
//   case 'i': i++; if(i<argc) ID3v1 = true; ID3v1_set = true; break;
   case 'd': i++; if(i<argc) conf.debug=atoi(argv[i]);
 break;
   case 'e': i++; if(i<argc) conf.eias=atoi(argv[i]); break;
   case 'l': i++; if(i<argc) conf.lineart=atoi(argv[i]); break;
   case 'V': i++; if(i<argc) conf.vis=atoi(argv[i]); break;
//   case 'T': strcpy(theme_name,optarg); theme_name_set = true; break;
//   case 'P': strcpy(mpg123params, optarg); mpg123params_set = true; break;
//   case 'E': strcpy(altparams, optarg); altparams_set = true; break;
//   case 'N': priority = atoi(optarg); priority_set = true; break;
//   case 'V': mixer_channel_volume = atoi(optarg); mixer_channel_volume_set = true; break;
//   case 'F': strcpy(find_command_line,optarg); find_command_line_set = true; break;
   case 'F': i++; if(i<argc) strcpy(conf.favsavepath, argv[i]); break;
   case 'M': i++; if(i<argc) strcpy(conf.midi_patch_dir, argv[i]); break;
   case 'm': i++; if(i<argc) strcpy(conf.midi_patch_cfg, argv[i]); break;
   case 'h': show_help(argv[0], conf_name); endwin(); exit(0);
   case 'H': show_formats(); endwin(); exit(0);
   default : printf("* Unrecognised option: %s\n", argv[i]);
    usleep(500000);
 //endwin(); exit(0);
 } else { argpath_i=i; strncpy(argpath, argv[i], PM-1); }
// if(argpath[0]!=0) strcpy(conf.wd, argpath);
 return argpath_i;
}


#include <termios.h>
#include <unistd.h>

#define stdinfd 0
#define stdoutfd 1
#define stderrfd 2
struct termios term_0;
struct termios term_1;
struct termios term_2;



// #define SETCOLOR(n,fg,bg,att) { color[n][0] = fg; color[n][1] = bg; color[n][2] = att; }
/* attron(A_REVERSE | A_BLINK); attron(), attroff(), attrset(), attr_get()
 A_NORMAL    Normal display (no highlight)  A_STANDOUT   Best highlighting mode of the terminal.
 A_UNDERLINE Underlining                    A_REVERSE    Reverse video
 A_BLINK     Blinking                       A_DIM        Half bright
 A_BOLD      Extra bright or bold           A_PROTECT    Protected mode
 A_INVIS     Invisible or blank mode        A_ALTCHARSET Alternate character set
 A_CHARTEXT  Bit-mask to extract a character  COLOR_PAIR(n) Color-pair number n  */
// screen element        fg      bg      style?
// colors can be: black, red, green, yellow, blue, magenta, cyan or white
int pcolor[12][3]={ // kot1
 {COLOR_WHITE, COLOR_BLACK, A_NORMAL}, // 0, plain
 {COLOR_RED, COLOR_BLACK, A_NORMAL}, // 1, borders
 {COLOR_WHITE, COLOR_BLACK, A_NORMAL}, // 2, text_normal
 {COLOR_WHITE, COLOR_BLACK, A_NORMAL}, // 3, text_active

 {COLOR_WHITE, COLOR_BLACK, A_NORMAL}, // 4, file
 {COLOR_WHITE, COLOR_BLACK, A_REVERSE}, // 5, file highligth

 {COLOR_WHITE, COLOR_BLUE, A_NORMAL}, // 6, file playing
 {COLOR_WHITE, COLOR_BLUE, A_REVERSE}, // 7, file playing highligth

 {COLOR_YELLOW, COLOR_BLACK, A_NORMAL}, // 8, dir
 {COLOR_YELLOW, COLOR_BLACK, A_REVERSE}, // 9, dir highlight

 {COLOR_WHITE, COLOR_BLACK, A_NORMAL}, // 10, text_help
 {COLOR_GREEN, COLOR_BLACK, A_NORMAL} // 11, text_playlist_tail
};
/////#############################
void set_colors(int pcolor[12][3]) { lf("set_colors"); int c;
 for(c=0; c<12; c++) { init_pair(c+1, pcolor[c][0], pcolor[c][1]); conf.style[c+1]=pcolor[c][2]; }
}

chtype MY_ACS_RTEE, MY_ACS_LTEE, MY_ACS_BTEE, MY_ACS_TTEE, MY_ACS_LRCORNER, MY_ACS_URCORNER,
 MY_ACS_ULCORNER, MY_ACS_LLCORNER, MY_ACS_VLINE, MY_ACS_HLINE;

/////##############
void lineart_nice() { lf("lineart_nice");
 MY_ACS_RTEE=ACS_RTEE; MY_ACS_LTEE=ACS_LTEE; MY_ACS_BTEE=ACS_BTEE; MY_ACS_TTEE=ACS_TTEE;
 MY_ACS_LRCORNER=ACS_LRCORNER; MY_ACS_URCORNER=ACS_URCORNER; MY_ACS_ULCORNER=ACS_ULCORNER;
 MY_ACS_LLCORNER=ACS_LLCORNER; MY_ACS_VLINE=ACS_VLINE; MY_ACS_HLINE=ACS_HLINE; return; }
/////################
void lineart_simple() { lf("lineart_simple");
 if(conf.lineart==1)
 { MY_ACS_ULCORNER=*"."; MY_ACS_URCORNER=*"."; MY_ACS_LLCORNER=*"`"; MY_ACS_LRCORNER=*"'"; }
 else { MY_ACS_ULCORNER=*"+"; MY_ACS_URCORNER=*"+"; MY_ACS_LLCORNER=*"+"; MY_ACS_LRCORNER=*"+"; }
 MY_ACS_LTEE=*"+"; MY_ACS_RTEE=*"+"; MY_ACS_TTEE=*"+"; MY_ACS_BTEE=*"+";
 MY_ACS_VLINE=*"|"; MY_ACS_HLINE=*"-";
}
/////##############
void draw_statics() { lf("draw_statics");
 bkgd(COLOR_PAIR(2)|conf.style[2]); // window color = border color
 mvhline(0, 1, MY_ACS_HLINE, conf.cols-2);  mvhline(conf.lines-4, 1, MY_ACS_HLINE, conf.cols-2);
 mvvline(1, 0, MY_ACS_VLINE, conf.lines-5); mvvline(1, conf.cols-1, MY_ACS_VLINE, conf.lines-5);
 mvaddch(0, 0, MY_ACS_ULCORNER);       mvaddch(0, conf.cols-1, MY_ACS_URCORNER);
 mvaddch(conf.lines-4, 0, MY_ACS_LLCORNER); mvaddch(conf.lines-4, conf.cols-1, MY_ACS_LRCORNER);

// mvaddch(conf.lines-2, 0, MY_ACS_ULCORNER); mvaddch(conf.lines-2, conf.cols-1, MY_ACS_URCORNER);
 mvaddch(conf.lines-1, 0, MY_ACS_LLCORNER); mvaddch(conf.lines-1, conf.cols-1, MY_ACS_LRCORNER);
 mvhline(conf.lines-1, 1, MY_ACS_HLINE, conf.cols-2);

 mvaddstr(conf.lines-2, 3, "___:__ [___:__] ___kHz ____kb/s __ch"); //khz:19,3  kbps:26,4  stereo:36,6
 mvaddstr(conf.lines-2, conf.cols-38, "Eias [_]  Shf [_]  Rep [_]  Vol ___%");
 mvchgat(conf.lines-3,3,conf.cols-5,conf.style[3],3,NULL);
 mvchgat(conf.lines-2,3,conf.cols-5,conf.style[3],3,NULL);
}

/////###############
void draw_listname() { lf("draw_listname");
 int i; for(i=1; i<conf.cols-1; i++) mvaddch(0, i, MY_ACS_HLINE);
 char *startchar, dots[4] = "..."; bool elipses = false;
 int l=strlen(listname); if(l<=conf.cols-4) startchar=listname;
 else { startchar=listname+(l-(conf.cols-4)+3); l=conf.cols-4; elipses = true; }
 mvaddch(0, ((conf.cols-l)/2)-1, MY_ACS_RTEE); mvaddch(0, (conf.cols+l)/2, MY_ACS_LTEE);
 if(elipses) { mvaddnstr(0, 2, dots, conf.cols-4); mvaddnstr(0, 5, startchar, conf.cols-4); }
 else mvaddnstr(0, (conf.cols-l)/2, startchar, conf.cols-4);
 refresh();
}
/////#####################
void set_listname(char *a) { lf("set_listname"); sprintf(listname, "(%d) %s", dmt+fmt, a); draw_listname(); }

/////###########
void draw_eias() { lf("draw_eias"); mvaddch(conf.lines-2, conf.cols-32,
 (conf.eias ? 'E'|COLOR_PAIR(4)|conf.style[4] : ' '|COLOR_PAIR(3))); refresh(); }
/////#############
void toggle_eias() { lf("toggle_eias"); conf.eias=!conf.eias; draw_eias(); load_dir(conf.wd); draw_list(); }

/////##############
void draw_shuffle() { lf("draw_shuffle");
 char c; switch(conf.shuffle) {
  case 0: c=*" "; break;
  case 1: c=*"S"; break;
  case 2: c=*"s"; break;
  default: c=*"?"; break; }
 mvaddch(conf.lines-2, conf.cols-23, c|COLOR_PAIR(4)|conf.style[4]); refresh(); }

/////####################
void restore_list_order() { lf("restore_list_order"); int i,j; bli *c;
 cur=d_i[cur]->a1;
 for(i=dmt-fmt2; i<dmt-1; ++i)
 {
  if(d_i[i]->a1==i) continue; else {
   j=i+1; while(d_i[j]->a1!=i && j<dmt) { ++j; }
   if(j<dmt) { c=d_i[i]; d_i[i]=d_i[j]; d_i[j]=c;
   } else dlog(9, "restore_list_order failed");
  }
 }
 draw_list();
}
void shuffle_f();
/////#####################
void toggle_shuffle(int a) { lfd("toggle_shuffle",a);
 if(conf.shuffle==2) restore_list_order();
 if(conf.shuffle!=0) conf.shuffle=0; else conf.shuffle=a;
 if(conf.shuffle==2) shuffle_f();
/*
 conf.shuffle+=1;
 if(conf.shuffle==2) shuffle_f();
 if(conf.shuffle>2) conf.shuffle=0;
 if(conf.shuffle==0) restore_list_order();
*/
 draw_shuffle(); }

/////#############
void draw_repeat() { lf("draw_repeat"); mvaddch(conf.lines-2, conf.cols-14,
 (conf.repeat ? 'R'|COLOR_PAIR(4)|conf.style[4] : ' '|COLOR_PAIR(3))); refresh(); }
/////###############
void toggle_repeat() { lf("toggle_repeat"); conf.repeat=!conf.repeat; draw_repeat(); }

/////#############
void draw_volume() { lf("draw_volume"); mvprintw(conf.lines-2, conf.cols-6, "%3d",get_volume());
 mvchgat(conf.lines-2, conf.cols-6, 3, conf.style[4], 4, NULL); refresh(); }

/////############
void ilurefresh() { lf("ilurefresh"); if(time(NULL)!=ilu) { ilu=time(NULL); refresh(); } }
/////##################
void draw_elapsedtime() { lf("draw_elapsedtime");
 char str[30]; if(elapsedtime<0) strcpy(str, "    :  ");
 else { remainingtime=totaltime-elapsedtime;
  if(conf.timeremaining_mode && remainingtime>=0)
       sprintf(str, "-%3d:%02d", (remainingtime)/60, (remainingtime)%60);
  else sprintf(str, " %3d:%02d", elapsedtime/60, elapsedtime%60); }
  mvaddstr(conf.lines-2, 2, str);
  mvchgat(conf.lines-2, 2, 7, conf.style[4], 4, NULL);
 ilurefresh();
}
/////#####################################################
void set_elapsedtime(int pelapsedtime, int premainingtime) { lf("set_elapsedtime");
 elapsedtime=pelapsedtime; remainingtime=premainingtime; draw_elapsedtime(); ilurefresh();
 if(elapsedtime>=0) { conf.lastpos=elapsedtime;
//  char lmsg[128]; sprintf(lmsg, "set_elapsedtime: lastpos: %d, pelapsedtime: %d",
//   conf.lastpos, pelapsedtime); dlog(9,lmsg);
 }
}
/////################
void draw_totaltime() { lf("draw_totaltime"); char str[30]; if(totaltime<=0) strcpy(str, "   :  ");
 else sprintf(str, "%3d:%02d", totaltime/60, totaltime%60);
 mvaddstr(conf.lines-2, 11, str);
 mvchgat(conf.lines-2, 11, 6, conf.style[4], 4, NULL);
// ilurefresh();
// dlog(0,"draw_totaltime");
 refresh();
}
/////####################
void set_totaltime(int a) { lf("set_totaltime"); if(a!=totaltime) { totaltime=a; draw_totaltime(); } }
/////#############################
void set_timeremaining_mode(int a) { lf("set_timeremaining_mode"); conf.timeremaining_mode=a; }

/////#############
void draw_format() { lf("draw_format"); int y=conf.lines-2;
 if(freq<=0) {
  mvaddstr(y, 19, "                    ");
  mvchgat(y, 19, 26, conf.style[3],3, NULL); }
 else {
  if(freq!=0)    mvprintw(y, 19, "%3dkHz ", freq/1000);
  if(bitrate!=0) mvprintw(y, 26, "%4dkb/s ", bitrate);
  if(chan!=0)    mvprintw(y, 35, "%2dch ", chan);
  mvchgat(y, 19, 36, conf.style[4],4, NULL);
//  mvchgat(y, 19, 3, conf.style[4], 4, NULL); mvchgat(y, 26, 4, conf.style[4], 4, NULL);
//  mvchgat(y, 36, 6, conf.style[4], 4, NULL);
 } refresh();
}
/////###############################
void set_format(int f, int b, int c) { lf("set_format"); freq=f; bitrate=b; chan=c; draw_format(); }

/////############
void draw_state() { lf("draw_stat"); switch(state) {
 case 0: mvaddstr(conf.lines-3, 2, "><"); break;  // unitited	(no slave)
 case 1: mvaddstr(conf.lines-3, 2, "<>"); break;  // forked
 case 2: mvaddstr(conf.lines-3, 2, "[]"); break;  // alive(stopped)
 case 12: mvaddstr(conf.lines-3, 2, "|]"); break; // alive(stopping)
 case 3: mvaddstr(conf.lines-3, 2, "|>"); break;  // playing
 case 4: mvaddstr(conf.lines-3, 2, "||"); break;  // paused
 case 14: mvaddstr(conf.lines-3, 2, "_|"); break; // pausing
 case 5: mvaddstr(conf.lines-3, 2, ">="); break;  // loading (sent load request to slave)
 case 6: mvaddstr(conf.lines-3, 2, "=>"); break;  // loading2 (slave reacted to load request)
 } mvchgat(conf.lines-3, 2, 2, conf.style[4], 4, NULL); refresh();
 sprintf(dmsg, "[draw_state: %d]", state); dlog(10,dmsg);
}
/////############
void set_noinfo() { lf("set_noinfo"); set_totaltime(-1); set_elapsedtime(-1,-1); set_format(-1,-1,-1);
 draw_state();
}

/////################
void set_state(int a) { lfd("set_state",a);
 if(conf.debug>=9)
 { char lmsg[128]; snprintf(lmsg, 127, "set_state: %d->%d", state, a); dlog(9,lmsg); }
 if(a==state) return;
 char lbuf[32]; switch(state) {
  case 2: if(a==5) state=a; break;
  case 5: if(a==6 || a==12) state=a; break;
  case 12: if(a<=1) state=a; break;
  default: state=a; break; }
 if(state==a) draw_state();
 else if(conf.debug>=9) { sprintf(lbuf, "ign state change: %d->%d", state,a); dlog(9,lbuf); }
}

/////############ Draw blank lines over playlist
void erase_list() { lf("erase_list");
 int x,y; for(y=1; y<1+conf.lh; y++) for(x=2; x<2+conf.lw; x++)
 mvaddch(y, x, ' '|COLOR_PAIR(2)); //refresh();
}
/* styles: 1:plain, 2:borders, 3:text_normal, 4:text_active, 5:song_normal, 6:song_highlighted,
           7:song_playing, 8:song_playing_highlighted, 9:dir_normal, 10:dir_highlighted,
           11:text_help, 12:text_playlist_tail */
/////###########
void draw_list() { lf("draw_list");
 int ox=2, oy=1, i, st, lw=conf.lw, lh=conf.lh, c=pos; bli *el;
 snprintf(dmsg, 1023, "draw_list: top: %d, pos: %d, cur: %d", top,pos,cur); dlog(9, dmsg);
 erase_list();
 for(i=0; i<lh; i++) if(top+i<dmt) { st=0; el=d_i[top+i]; if(el)
  {
   switch(conf.fullpath) {
    case 2:  mvaddnstr(oy+i, ox, el->v2, lw); break;
    case 1:  mvaddnstr(oy+i, ox, el->v1, lw); break;
    default: mvaddnstr(oy+i, ox, el->v, lw); break;
   }
//dlog(el->v1);
//  if(el->v1) for(cc=strlen(el->v1); cc<lw; cc++) mvaddch(oy+i, ox+cc, ' '|COLOR_PAIR(2));
   if(el->a2<0)        { if(top+i==c) st=10; else st=9; } // dir
   else if(top+i!=cur) { if(top+i==c) st=6; else st=5; } // file
   else                { if(top+i==c) st=8; else st=7; } // file cur
   mvchgat(oy+i, ox, lw, conf.style[st], st, NULL);
  }
  else { sprintf(dmsg, "dl: el==NULL, top:%d, i:%d, dmt:%d, fmt:%d", top, i, dmt, fmt); dlog(0,dmsg); }
 } // while(i<lh) { for(cc=0; cc<lh; cc++) mvaddch(oy+i, ox+cc, ' '|COLOR_PAIR(12)); i++; }
 refresh();
}
/////##################### Some code to scroll the window to show this selection
void scrollto(int showpos) { lf("scrollto"); char lmsg[128];
 if(showpos<0) showpos=0; else if(showpos>=dmt) showpos=dmt-1;  pos=showpos;
 snprintf(lmsg,127,"scrollto: showpos: %d, top: %d, lh: %d, pos: %d", showpos, top, conf.lh, pos);
 dlog(9,lmsg);
 if(showpos<top || showpos>top+conf.lh-1)
 { top=showpos-conf.lh/2; if(top<0) top=0; else if(top+conf.lh-1>dmt) top=dmt-conf.lh; }
 draw_list(); 
// snprintf(lmsg,127,"scrollto2: showpos: %d, top: %d, lh: %d, pos: %d", showpos, top, conf.lh, pos);
 dlog(9,lmsg);
}

//FIXME: use scrollto() ?
/////###########
void action_up() { lf("action_up"); --pos; scrollto(pos); }
/////#############
void action_down() { lf("action_down"); ++pos; scrollto(pos); }
/////#############
void action_home() { lf("action_home"); pos=top=0; scrollto(pos); }
/////############
void action_end() { lf("action_end"); pos=dmt-1; scrollto(pos); }
/////#############
void action_pgup() { lf("action_pgup"); pos-=conf.lh; scrollto(pos); }
/////#############
void action_pgdn() { lf("action_pgdn"); pos+=conf.lh; scrollto(pos); }


/////#################
void toggle_fullpath() { lf("toggle_fullpath"); conf.fullpath++; if(conf.fullpath>2) conf.fullpath=0; draw_list(); }
/////############
void toggle_vis() { lf("toggle_vis"); conf.vis++; if(conf.vis>1) conf.vis=0;
 char lmsg[64]; sprintf(lmsg, "vis %d\n", conf.vis);
 slave_s(lmsg);
}


/////################
void draw_clip_info() { lf("draw_clip_info");
 int y, ox=2, oy=1+1, lw=conf.lw, lh=conf.lh; erase_list();
 for(y=0; y<lh && y<8; y++) { switch(y) {
   case 0: snprintf(dmsg, lw, "Path:    %s", d_i[cur]->v);  mvaddstr(oy+y, ox, dmsg); break;
   case 1: snprintf(dmsg, lw, "File:    %s", d_i[cur]->v1);  mvaddstr(oy+y, ox, dmsg); break;
   case 3: snprintf(dmsg, lw, "Title:   %s", clip_title);   mvaddstr(oy+y, ox, dmsg); break;
   case 4: snprintf(dmsg, lw, "Album:   %s", clip_album);   mvaddstr(oy+y, ox, dmsg); break;
   case 5: snprintf(dmsg, lw, "Year:    %s", clip_year);    mvaddstr(oy+y, ox, dmsg); break;
   case 6: snprintf(dmsg, lw, "Genre:   %s", clip_genre);   mvaddstr(oy+y, ox, dmsg); break;
   case 7: snprintf(dmsg, lw, "Comment: %s", clip_comment); mvaddstr(oy+y, ox, dmsg); break;
  } mvchgat(oy+y, ox, lw, conf.style[3], 3, NULL); } refresh();
}
/////#####################
void draw_clip_shortinfo() { lf("draw_clip_shortinfo");
 static char lbuf[1024]; int l,i=0;
// snprintf(dmsg, conf.cols, "%s - %s (%s, %s)", clip_title, clip_artist, clip_year, clip_album);
 if(!d_i[cur]) return;

 if(clip_title[0]==0 && clip_artist[0]==0 && clip_album[0]==0 && clip_year[0]==0 && clip_comment[0]==0)
 { if(0)d(0, d_i[cur]->v2); return; }

 if(strncmp(clip_title, "tmp/oscptmp-", 12)==0) strncpy(lbuf, clip_title+12, 1023);
 else strncpy(lbuf, clip_title, 1023);

 l=strlen(lbuf); if(clip_artist[0]!=0) { strcat(lbuf, " - "); strncat(lbuf, clip_artist, 1000-l);
  l+=3+strlen(clip_artist); }
 if(clip_year[0]!=0 || clip_album[0]!=0 || clip_comment[0]!=0) { l+=3; strcat(lbuf, " (");
  if(clip_year[0]!=0) { i++; strncat(lbuf, clip_year, 1000-l); l+=strlen(clip_year); }
  if(clip_album[0]!=0) { if(i>0) { l+=2; strcat(lbuf, ", "); } i++;
   strncat(lbuf, clip_album, 1000-l); l+=strlen(clip_album); }
  if(clip_comment[0]!=0) { if(i>0) { l+=2; strcat(lbuf, ", "); } i++;
   strncat(lbuf, clip_comment, 1000-l); l+=strlen(clip_comment); }
  l+=1; strcat(lbuf, ")");
 }

// if(strlen(dmsg)>8)
// dlog(lbuf);
// if(l>0)
 if(0)d(0, lbuf); else {
  mvaddnstr(conf.lines-3, 5, lbuf, conf.cols-7);
  static int c; for(c=strlen(lbuf); c<conf.cols-7; c++)
   mvaddch(conf.lines-3, 5+c, ' '|COLOR_PAIR(4)|conf.style[4]);
   mvchgat(conf.lines-3, 5, conf.cols-7, conf.style[4], 4, NULL);
  refresh();
 }

 FILE *f2=fopen("/tmp/oscp-now-playing.txt","w");
 if(f2) { fwrite(lbuf, strlen(lbuf), 1, f2); fclose(f2); }
// else d(0, d_i[cur]->v2);
}

/////###############
void window_resize() { lf("window_resize");
 if(slave_pid==0) return;
 endwin(); refresh();
// char lmsg[128]; snprintf(lmsg,127,"window_resize called, L:%d, C:%d", LINES, COLS);

 conf.lines=LINES; conf.cols=COLS; conf.lw=COLS-4; conf.lh=LINES-5; clear();
 draw_statics(); draw_listname(); draw_state(); draw_clip_shortinfo(); draw_elapsedtime();
 draw_totaltime(); draw_format(); draw_eias(); draw_shuffle(); draw_repeat(); draw_volume();
 draw_list();
}
/////#############
void window_init() { lf("window_init"); if(conf.lineart) lineart_simple(); else lineart_nice();
 tcgetattr(stdinfd, &term_0); tcgetattr(stdoutfd, &term_1); tcgetattr(stderrfd, &term_2);
 initscr(); start_color(); set_colors(pcolor); cbreak(); noecho(); curs_set(0); // disable cursor
 leaveok(stdscr, TRUE); keypad(stdscr, TRUE); conf.lines=LINES; conf.cols=COLS; //pos=top=0;
 window_resize();

 struct sigaction sa; memset(&sa, 0, sizeof(struct sigaction));
 sa.sa_handler = window_resize; sigaction(SIGWINCH, &sa, NULL);
}
/////############
void window_end() { lf("window_end");
 bkgd(COLOR_PAIR(1)); clear(); endwin(); tcsetattr(stdinfd, TCSAFLUSH, &term_0);
 tcsetattr(stdoutfd, TCSAFLUSH, &term_1); tcsetattr(stderrfd, TCSAFLUSH, &term_2);
 free_df();
}

////###################
int ext2type(char *ext) { lf("ext2type"); int i; char **t;
 static char *tGME[11]={"ay","gbs","gym","hes","kss","nsf","nsfe","sap","spc","vgm",NULL}; // libgme
 static char *tSP2[4]={"sid","psid","info",NULL}; // sidplay2-slave
 static char *tMPL[17]={"mp3","wav","ogg","flac","ape","mpg","mpeg","mpc","aac","m4a","mp2","wma","wmv",
  "wv","asf","rm", NULL}; // mplayer
 static char *tPLS[2]={"m3u",NULL}; // m3u playlist
 static char *tZIP[2]={"zip",NULL}; // zip archive
 static char *tRAR[2]={"rar",NULL}; // rar archive
#ifdef TIMI_WILDMIDI
 static char *tTIM[7]={"mid","midi","xmi","mus","hmi","hmp",NULL}; // wildmidi
#else
 static char *tTIM[5]={"mid","midi","xmi","mus",NULL}; // timidity++-slave
#endif
 static char *tXMP[30]={"mod","med","xm","it","s3m","dbm","psm","umx","okt","digi","669","mtm",
  "mtp","ac1d","di","eu","kris","lax","liq","dtm","ptm","rtm","stm","amf","dmf","imf","amd",
  "rad","hsc",NULL}; // xmp-slave
 static char *tIGN[15]={"lha","txt","diz","html","htm","readme","asm","smpl","smp"
,"png","gif","bmp","jpg","jpeg"
,NULL}; // ignored (known unplayable)
 static char *tSC68[3]={"sc68","sndh",NULL}; // sc68 (atari)
 static char *tMDX[2]={"mdx",NULL}; // mdxplay (X68000)
 static char *tSPC[2]={"spc",NULL}; // spcplayer-slave (snes)
 static char *tNSF[2]={"nsf",NULL}; // nosefart-slave (nes)
 static char *tFC[4]={"fc","fc13","fc14",NULL}; // fc14dec
 static char *tUADE[151]={"adsc","abk","ac1d","ahx","alp","amc","aon","aon8","ast","avp","bp","bp3",
  "bpsm","bd","bds","bss","chan","cin","cm","core","cust","cus","dat","dh","di","dl","dlm1","dlm2",
  "dln","dm1","dm2","dns","doda","dsc","dsr","dum","dmu","dss","dw","dz","ea","ems","emsv6","eu",
  "ex","fc","fc13","fc14","fc3","fc4","fcm","fp","fred","fw","glue","gray","hd","hip","hip7","hipc",
  "hn","ims","is","is20","jam","jcb","jcbo","jd","jmf","jo","jpn","jpnd","jpo","jpold","kh","kris",
  "ksm","lax","ma","mc","mcmd","mco","mcr","mcs","md","mdat","mdst","mii","midi","mk2","mkii","ml",
  "mmdc","mok","mon","mso","mtp2","mug","mug2","mw","pap","pc","psa","psf","pt","puma","pvp","qpa",
  "qts","rh","rk","s","s7g","sa","sc","sct","scumm","sdata","sfx","sfx13","sid1","sid2","sidmon",
  "sjs","sm","smus","sng","snx","soc","sog","sonic","spl","sqt","src","sun","syn","synmod","tf",
  "tfmx","tfx","thm","thx","tiny","tme","tronic","uds","unic","vss","wb","ym",NULL}; // uade
 static char *tSAP[15]={"sap","cm3","cmc","cmr","cms","dmc","dlt","mpd","mpt","rmt","tm2","tm8",
  "tmc","fc",NULL}; // asapconv (atari)

// first match wins
 i=0; t=tGME; while(t[i]!=NULL) { if(strcasecmp(ext, t[i])==0) return 9; i++; }
 i=0; t=tXMP; while(t[i]!=NULL) { if(strcasecmp(ext, t[i])==0) return 4; i++; }
 i=0; t=tMPL; while(t[i]!=NULL) { if(strcasecmp(ext, t[i])==0) return 2; i++; }
 i=0; t=tSP2; while(t[i]!=NULL) { if(strcasecmp(ext, t[i])==0) return 5; i++; }
 i=0; t=tPLS; while(t[i]!=NULL) { if(strcasecmp(ext, t[i])==0) return -2; i++; }
 i=0; t=tZIP; while(t[i]!=NULL) { if(strcasecmp(ext, t[i])==0) return -3; i++; }
 i=0; t=tRAR; while(t[i]!=NULL) { if(strcasecmp(ext, t[i])==0) return -4; i++; }
// 12 reserved for mplayer http* links
 i=0; t=tTIM; while(t[i]!=NULL) { if(strcasecmp(ext, t[i])==0) return 3; i++; }
 i=0; t=tIGN; while(t[i]!=NULL) { if(strcasecmp(ext, t[i])==0) return -9; i++; }
 i=0; t=tSC68;while(t[i]!=NULL) { if(strcasecmp(ext, t[i])==0) return 17; i++; }
 i=0; t=tMDX; while(t[i]!=NULL) { if(strcasecmp(ext, t[i])==0) return 18; i++; }
 i=0; t=tSPC; while(t[i]!=NULL) { if(strcasecmp(ext, t[i])==0) return 6; i++; }
 i=0; t=tNSF; while(t[i]!=NULL) { if(strcasecmp(ext, t[i])==0) return 7; i++; }
 i=0; t=tFC;  while(t[i]!=NULL) { if(strcasecmp(ext, t[i])==0) return 8; i++; }
 i=0; t=tUADE;while(t[i]!=NULL) { if(strcasecmp(ext, t[i])==0) return 1; i++; }
 i=0; t=tSAP; while(t[i]!=NULL) { if(strcasecmp(ext, t[i])==0) return 16; i++; }

//sprintf(dmsg, "ext2type: %d (eias:%d)", type, conf.eias); dlog(dmsg);
 return 0;
}
////#########################
int file2type(char *filename) { lf("file2type"); int type=0;
/* char t[32]; unsigned char *c=(unsigned char *)t; */
/* FILE *f=fopen(filename, "r"); if(!f) return 0; fread(t,32,1,f); fclose(f);
//printf("[%2x %2x %2x %2x]\n", c[0], c[1], c[2], c[3]);
      if(strncmp(t+1, "PNG",3)==0) type=1;
 else if(c[0]==0xff && (c[1]==0xd8 || c[1]==0xd9)) type=2;
 else if(strncmp(t, "GIF8", 4)==0) type=3;
 else if(strncmp(t, "II", 2)==0 || strncmp(t, "MM", 2)==0) type=4;
 else if(strncmp(t, "BM", 2)==0) type=5;
 else if(c[0]==0 && c[1]==0 && c[2]==1 && c[3]==0) type=6;
 else if(strncasecmp(t+3, "XPM", 3)==0) type=7;
 else if(strncasecmp(t, "%PDF", 4)==0) type=11;
 else */ { char *ext=rindex(filename, *"."); if(ext) type=ext2type(ext); }
 return type;
}


//FIXME: prioritize ".."
////#####################
int bcmp2(bli *i, bli *j) { lf("bcmp2");
 int l;
 l=strlen(i->v); if(l>3 && strcmp(i->v+l-3,"/..")==0) return -1;
 l=strlen(j->v); if(l>3 && strcmp(j->v+l-3,"/..")==0) return 1;
 return strcasecmp(i->v, j->v); }

// This function is copyright 2001 Simon Tatham.
/////###################################################
bli *listsort(bli *list, int is_circular, int is_double) { lf("listsort"); if (!list) return NULL;
 bli *p, *q, *e, *tail, *oldhead;  int insize, nmerges, psize, qsize, i;
 insize = 1;
 while (1) { p=list;
  oldhead = list; // only used for circular linkage
  list = NULL; tail = NULL; nmerges = 0;  // count number of merges we do in this pass
  while (p) { nmerges++;  // there exists a merge to be done
   // step `insize' places along from p
   q = p; psize = 0;
   for (i = 0; i < insize; i++) { psize++;
    if (is_circular) q = (q->next == oldhead ? NULL : q->next); else    q = q->next;
    if (!q) break;
   }

   // if q hasn't fallen off end, we have two lists to merge
   qsize = insize;

   // now we have two lists; merge them
   while (psize > 0 || (qsize > 0 && q)) {

    // decide whether next element of merge comes from p or q 
    if (psize == 0) { // p is empty; e must come from q.
     e = q; q = q->next; qsize--;  if (is_circular && q == oldhead) q = NULL;
    } else if (qsize == 0 || !q) { // q is empty; e must come from p.
     e = p; p = p->next; psize--;  if (is_circular && p == oldhead) p = NULL;
    } else if (bcmp2(p,q) <= 0) { // First element of p is lower (or same); e must come from p.
     e = p; p = p->next; psize--;  if (is_circular && p == oldhead) p = NULL;
    } else { // First element of q is lower; e must come from q.
     e = q; q = q->next; qsize--; if (is_circular && q == oldhead) q = NULL;
    }

    // add the next element to the merged list
    if (tail) { tail->next = e; } else { list = e; }
    if (is_double) { e->prev = tail;} // Maintain reverse pointers in a doubly linked list.
    tail = e;
   }

   p = q; // now p has stepped `insize' places along, and q has too
  }
  if (is_circular) { tail->next = list; if (is_double) list->prev = tail; } else tail->next = NULL;

  // If we have done only one merge, we're finished.
  if (nmerges <= 1) return list; // allow for nmerges==0, the empty list case

  insize *= 2; // Otherwise repeat, merging lists twice the size
 }
}


/////############
void dl(int what) { lf("dl"); char tt[1024]; dlog(0,"---");
 if(what & 1) { dlog(0,"[1]");
  sprintf(tt, "dh:%4d ", dmt); if(d_head) strcat(tt, d_head->v); dlog(0,tt);
  sprintf(tt, "dhN     "); if(d_head && d_head->next) strcat(tt, d_head->next->v); dlog(0,tt);
  sprintf(tt, "dhNN    "); if(d_head && d_head->next && d_head->next->next) strcat(tt, d_head->next->next->v); dlog(0,tt);
  sprintf(tt, "dt      "); if(d_tail) strcat(tt, d_tail->v); dlog(0,tt);
  sprintf(tt, "dtP     "); if(d_tail && d_tail->prev) strcat(tt, d_tail->prev->v); dlog(0,tt);
  sprintf(tt, "fh:%4d ", fmt); if(f_head) strcat(tt, f_head->v); dlog(0,tt);
  sprintf(tt, "fhN     "); if(f_head && f_head->next) strcat(tt, f_head->next->v); dlog(0,tt);
  sprintf(tt, "fhNN    "); if(f_head && f_head->next && f_head->next->next) strcat(tt, f_head->next->next->v); dlog(0,tt);
  sprintf(tt, "ft      "); if(d_head) strcat(tt, f_tail->v); dlog(0,tt);
  sprintf(tt, "ftP     "); if(f_tail && f_tail->prev) strcat(tt, f_tail->prev->v); dlog(0,tt);
 }
 if(what & 2) { dlog(0,"[2]");
  blist(d_head, 1);// usleep(1000000);
  blist(f_head, 1);// usleep(1000000);
 }
 dlog(0,"---.");
}

/////###############
void save_playlist() { lf("save_playlist");
 FILE *f; bli *c; int i=0; f=fopen("/tmp/oscp.m3u","w"); if(f) {
  for(c=d_head; c!=NULL; c=c->next) {
   i++; if(i>MAXPLAYLIST) { dlog(0,"MAXPLAYLIST reached, abort, abort!"); break; }
//   if(c!=d_head || c->a2>=0) { fputs(c->v, f); fputs("\n", f); }
   if(c->v[0]!=0) { fputs(c->v, f); if(c->a2==-1) fputs("/", f);  fputs("\n", f); }
  } fclose(f); } sprintf(dmsg, "save_playlist: %d (dmt:%d, fmt:%d)", i, dmt, fmt); dlog(0,dmsg); }

/////###########
void shuffle_f() { lf("shuffle_f");
 bli *c; int i,r,ocur=d_i[cur]->a1;

// char lmsg[1024];
// sprintf(lmsg, "shuffle_f: dmt: %d, fmt: %d, fmt2: %d", dmt, fmt, fmt2); dlog(9,lmsg);

// for(i=dmt-fmt2; i<dmt-1; ++i) { d_i[i]->nextS=d_i[i+1]; } if(fmt2>0) d_i[i]->nextS=f_head2;

 for(i=dmt-fmt2; i<dmt-1; ++i) {
  r=rr(dmt-fmt2,dmt-1);
  c=d_i[i]; d_i[i]=d_i[r]; d_i[r]=c;
  if(d_i[i]->a1==ocur) cur=i;
  else if(d_i[r]->a1==ocur) cur=r;
 } // if(d_i[i]->a1==ocur) cur=i;
// sprintf(lmsg, "shuffle_f: ocur: %d, cur: %d", ocur, cur); dlog(9,lmsg);

 draw_list();
}

/////##############################
void sort_join_index_df(char *curr) { lf("sort_join_index_df");
 // sort them
 d_head=listsort(d_head,0,0); f_head=listsort(f_head,0,0);

//dlog(curr); dlog(conf.file);
 // update index and tails
 bli *c, *c0=NULL; int i=0; cur=-1;
 for(c=d_head; c!=NULL; c=c->next) { d_i[i]=c; c->a1=i;
  if(cur==-1 && curr!=NULL &&
  (strcmp(curr,c->v)==0 || strcmp(conf.file,c->v)==0)) cur=i; ++i; d_tail=c; }
//sprintf(dmsg, "i:%d, cur:%d", i, cur); dlog(dmsg);
 for(c=f_head; c!=NULL; c=c->next) { d_i[i]=c; c->a1=i;
  c->prev=c0; c0=c;
  c->prevS=c->prev;
  c->nextS=c->next;
  if(cur==-1 && curr!=NULL &&
  (strcmp(curr,c->v)==0 || strcmp(conf.file,c->v)==0)) cur=i; ++i;
  f_tail=c; }
//sprintf(dmsg, "i:%d, cur:%d", i, cur); dlog(dmsg);

 if(conf.shuffle==0) draw_list();
 if(conf.shuffle==2) shuffle_f();

 // join lists
 if(f_head!=NULL) {
  fmt2=fmt;
  if(d_head==NULL) { f_head2=f_head; d_tail=f_tail; d_head=f_head;
   f_head=NULL; f_tail=NULL; dmt=fmt; fmt=0; }
  else { f_head2=f_head; d_tail->next=f_head; f_head->prev=d_tail; d_tail=f_tail;
   f_head=NULL; f_tail=NULL; dmt+=fmt; fmt=0;
  }
 }

 // display
 if(cur<0) cur=0; scrollto(cur);
}

//      7748  11-18-2003 18:24   sc68files/505 - Checkpoint/Atari ST/Manic (YM Rockerz - 2003).sc68
/////####################################
void parse_zip_line(char *dst, char *src) { lf("parse_zip_line");
 int i, j=0, k=0, l=strlen(src); dst[0]=0;
 if(l>0 && src[l-1]==*"\n") { src[l-1]=0; l--; } if(l>0 && src[l-1]==*"/") return;
 for(i=0; i<l && j<7; i++) {
  if(k==0 && src[i]!=*" ") { k=1; j++; }
  if(k==1 && src[i]==*" ") { k=0; j++; }
 }
 if(i>=0 && i<l) strcpy(dst, src+i-1);
// printf("[src: %s]\n[dst: %s]\n", src, dst);
}

// rar:
// Setup
//                     0        0   0% 17-06-03 15:53  .D.....   00000000 m0  2.0
// Chs/98lang.dat
//                 24554    10047  40% 01-06-02 17:32  .....A.   57CADF0D m5e 2.9
/////####################################
void parse_rar_line(char *dst, char *src) { lf("parse_rar_line"); int l; char *t; dst[0]=0;
 t=index(src, *"\n"); if(!t) return;
 l=t-src; if(l>=PM || l<2 || strstr(t, ".D.")) return;
 strncpy(dst, src+1, l-1); dst[l-1]=0;
}

#include <zzip/zzip.h>
/////#########################
void load_vdir_zip(char *adi0) { lf("load_vdir_zip");
 dlog(1, "load_vdir_zip");
 ZZIP_DIR* d=zzip_dir_open(adi0,0); ZZIP_DIRENT de;
 if(!d) { dlog(9,"load_vdir_zip failed"); return; }

 char adi[PM]; // free_df() will destroy adi0
 strncpy(adi, adi0, 4095);
 
 free_df();

 char tmp[PM]; int type=0;

 while(zzip_dir_read(d,&de)) {
//  printf("[%s | %i, %i]\n", dirent.d_name, dirent.d_csize, dirent.st_size);
  if(de.st_size>0) { sprintf(tmp, "%s#zip#/%s", adi, de.d_name); baddU(0, 0, type, tmp); }
 } zzip_dir_close(d);

 // add '..' entry
 char *v=malloc(strlen(adi)+1+3); snprintf(tmp, PM-1, "%s/..", adi);
 if(v) { normalize_path(v,tmp,strlen(conf.wd)+3); baddU(0, 0, -1, v); }

 sprintf(buf, "load_vdir_zip: dmt:%d, fmt:%d", dmt, fmt); dlog(9,buf);
 sort_join_index_df(conf.file);

 save_playlist(); strcpy(conf.wd, adi); set_listname(conf.wd);
}
/////#####################
void load_vdir(char *adi0) { lf("load_vdir"); char *v=rindex(adi0, *".");
 if(v && strcmp(v+1, "zip")==0) { load_vdir_zip(adi0); return; }

 ds(1, "load_vdir", adi0);

 char cmd[128+PM], tmp[PM], d_path[PM], buf[4096], adi[PM];
 strcpy(adi, adi0); // need to save it before bfree in free_df()
 FILE *fcmd=NULL; int l, type=0, flag=1, mode=0; // playlist
 if(v && strcmp(v+1, "zip")==0) mode=1; // zip archive
 if(v && strcmp(v+1, "rar")==0) mode=2; // rar archive
 if(mode==1 || mode==2) if(index(adi, *"\\") || index(adi, *"\"")) return;

 if(mode==0) { fcmd=fopen(adi, "r"); }
 if(mode==1) { sprintf(cmd, "unzip -lqq \"%s\"", adi); fcmd=popen(cmd, "r"); }
 if(mode==2) { flag=0; sprintf(cmd, "unrar v -c- -cfg- \"%s\"", adi); fcmd=popen(cmd, "r"); }
 if(!fcmd) return;

 free_df();

 while(fgets(buf, 4095, fcmd) && dmt+fmt<MAXPLAYLIST) { d_path[0]=0;
  if(flag==1 &&
  (strncmp(buf,"http://",7)==0 || strncmp(buf,"https://",8)==0 || strncmp(buf,"mms://",6)==0)) {
   l=strlen(buf); if(l>0 && buf[l-1]==*"\n") { buf[l-1]=0; l--; }
   baddU(0, 0, 12, buf); // 12 == mplayer http* type
  } else if(flag==1) {
   if(mode==0) {
if(0&&buf[0]!=*"/") { //FIXME: save/load playlists's wd
// char lmsg[4096]; sprintf(lmsg, "[conf.wd: %s]", conf.wd); dlog(9, lmsg);
 strcpy(d_path,conf.wd); if(strcmp(conf.wd,"/")!=0) strcat(d_path, "/");
} strcat(d_path, buf);
   }
   if(mode==1) { parse_zip_line(d_path, buf); }
   if(mode==2 && flag==1) { if(buf[0]==*"-") { flag++; break; }
    fgets(buf+strlen(buf), 4095, fcmd); // 2 lines per entry
//    dlog(9,buf);
    parse_rar_line(d_path, buf); }
   l=strlen(d_path);
   if(l>0 && d_path[l-1]==*"\n") { d_path[l-1]=0; l--; }
   if(l>0 && d_path[l-1]==*"/") continue;
//  if(l>0 && d_path[l-1]==*"/") type=-1; else type=0;
   if(mode==0) { baddU(0, 0, type, d_path); }
   if(mode==1) { sprintf(tmp, "%s#zip#/%s", adi, d_path); baddU(0, 0, type, tmp);
dlog(9,d_path); dlog(9,tmp);
 }
   if(mode==2) { sprintf(tmp, "%s#rar#/%s", adi, d_path); baddU(0, 0, type, tmp); }
  }

  if(mode==2 && strncmp(buf, "------", 6)==0) flag++;
 }
 if(mode==0) fclose(fcmd);
 if(mode==1) pclose(fcmd);
 if(mode==2) pclose(fcmd);

 v=NULL; // add '..' entry
 if(strcmp("/tmp/oscp.m3u", adi)!=0) { v=malloc(strlen(adi)+1+3); sprintf(tmp, "%s/..", adi); }
 else { v=malloc(strlen(conf.wd)+1+3); sprintf(tmp, "%s/..", conf.wd); }
 if(v) { normalize_path(v,tmp,strlen(conf.wd)+3); baddU(0, 0, -1, v); }

 sprintf(buf, "load_vdir: dmt:%d, fmt:%d", dmt, fmt); dlog(9,buf);
 sort_join_index_df(conf.file);

 if(strcmp("/tmp/oscp.m3u", adi)!=0) { if(mode>0) save_playlist(); strcpy(conf.wd, adi);
  set_listname(conf.wd); } else set_listname("<vplst>");
}
/////####################
void load_last_playlist() { lf("load_last_playlist"); load_vdir("/tmp/oscp.m3u"); }


#include <errno.h>
/////########################
void load_dir(char *dir_name) { lf("load_dir");
 char lmsg[4096]; struct stat sb; int sr; char tmp[PM],tmp2[PM],olddir[PM];

 ds(1, "loaddir:dir_name:", dir_name);

 strcpy(olddir, conf.wd);

 if(dir_name[0]==0) { load_last_playlist();
  if(dmt+fmt>0) { scrollto(cur); set_listname("<vplst>"); return; }
 }
 if(dir_name[0]==0 && conf.wd[0]==0) strcpy(conf.wd, getenv("PWD"));
 if(dir_name[0]!=0) {
  if(strcmp(dir_name, ".")==0) strcpy(tmp2, getenv("PWD")); else strcpy(tmp2, dir_name);
  normalize_path(conf.wd, tmp2, PM);
//ds(9, "loaddir:normalize_path0", tmp2);
//ds(9, "loaddir:normalize_path1", conf.wd);
 }

 // is it a playlist?
 sr=stat(conf.wd, &sb); if(S_ISREG(sb.st_mode)) {
  ds(9, "loaddir, file=>playlist", conf.wd);
  load_vdir(conf.wd); return; }
 ds(9, "loaddir, regular_dir", conf.wd);

 DIR *di = opendir(conf.wd);
 if(!di) { sprintf(tmp,"opendir failed '%s': %s", conf.wd, strerror(errno));d(0,tmp);
  char *t=rindex(conf.wd, *"/");
  if(t) t[0]=0; else strcpy(conf.wd, getenv("PWD")); load_dir("");
  return; }

 struct dirent *entry; const char *d_name; char d_path[PATH_MAX];

 free_df();

 // fix for //
 char enfmt[8]; strcpy(enfmt,"%s/%s"); if(strcmp(conf.wd,"/")==0) strcpy(enfmt,"%s%s");

 while((entry=readdir(di))!=NULL && dmt+fmt<MAXPLAYLIST) {
  d_name=entry->d_name; sprintf(d_path, "%s/%s", conf.wd, d_name);

  // handle symlinks and sshfs entries
  if((entry->d_type==DT_LNK || entry->d_type==DT_UNKNOWN)
  && (sr=stat(realpath(d_path,tmp), &sb))==0)
  {
   if(S_ISDIR(sb.st_mode))entry->d_type=DT_DIR;
   else if(S_ISREG(sb.st_mode))entry->d_type=DT_REG;
  }
  if(entry->d_type==DT_REG) { sprintf(tmp, "%s/%s", conf.wd, d_name); baddU(0, 0, 0, tmp); }
  else if(entry->d_type==DT_DIR && strcmp(d_name, ".")!=0)
  { sprintf(tmp, enfmt, conf.wd, d_name); baddU(0, 0, -1, tmp); }
  else { snprintf(lmsg, 4095, "load_dir:unhandled entry: (%d) %s", entry->d_type, d_name); dlog(10, lmsg); }

sprintf(lmsg, "loaddir:readdir: (%d) %s", entry->d_type, entry->d_name); d(10,lmsg);

 }
 if(closedir(di)){sprintf(tmp,"Could not close '%s': %s", tmp2, strerror(errno)); d(0,tmp); }

 sort_join_index_df(olddir); set_listname(conf.wd);
 unlink("/tmp/oscp.m3u");
}



/////######################################
void make_recursive_list(char *ndi, int rl) { lf("make_recursive_list");
 void *v; char tmp[PM],curdir[PM];
 if(rl==0) dlog(0,"make_recursive_list, rl==0");

 DIR *di; if(ndi==NULL) strcpy(curdir, conf.wd); else strcpy(curdir, ndi); di=opendir(curdir);
 if(!di) return;

 if(rl==0) { free_df(); v=malloc(strlen(curdir)+1); strcpy(v, curdir); baddU(0, 0, -1, v); }

 struct dirent *entry; const char *d_name; struct stat sb; int sr; char d_path[PM];

 while((entry=readdir(di))!=NULL && dmt+fmt<MAXPLAYLIST) {
  d_name=entry->d_name; sprintf(d_path, "%s/%s", curdir, d_name);

  // handle symlinks
  if(entry->d_type==DT_LNK && (sr=stat(realpath(d_path,tmp), &sb))==0)
  { if(S_ISDIR(sb.st_mode))entry->d_type=DT_DIR; else if(S_ISREG(sb.st_mode))entry->d_type=DT_REG; }

  if(entry->d_type==DT_REG) { baddU(0,0,0,d_path); }

  if(entry->d_type==DT_DIR) { if(strcmp(d_name,".")!=0 && strcmp(d_name,"..")!=0) {
   sprintf(tmp, "%s/%s", curdir, d_name); make_recursive_list(tmp, rl+1);
  } }

 } closedir(di);

 if(rl==0) {
  sort_join_index_df(conf.file); sprintf(tmp, "%s/<vplstd>", conf.wd); set_listname(tmp);
  save_playlist();
 }
}


/////#####################
void wait_for_stop(int fd) { lf("wait_for_stop");
 d(9, "wait_for_stop");
// return;
 if(fd<0) { dlog(9, "wait_for_stop: fd<0"); return; }
 int rc,rb,rbt; char buf[4096];
 int stopped=0;

 fd_set fsa, fsr; struct timeval tv;

 while(stopped==0) { rbt=0; buf[0]=0;
  do {
   tv.tv_sec=0; tv.tv_usec=100000; FD_ZERO(&fsr);
   if(slave_recv>0) FD_SET(slave_recv, &fsa); else stopped=3;
   rc=select(FD_SETSIZE, &fsa, NULL, NULL, &tv);
   if(rc<0) { stopped=2; dlog(9, strerror(errno)); }
   else if(rc>0) { rb=read(fd, buf+rbt, 1); rbt+=rb; }
   else usleep(100000);
  } while(stopped==0 && rbt<=4095 && buf[rbt]!=*"\n");
  if(strncmp(buf, "EOF code: stop requested", 24)==0) { state=2; stopped=1; set_noinfo(); }
 }
if(stopped==1) dlog(9,"slave stopped");
else if(stopped==2) dlog(9,"slave stopped (died)");
else if(stopped==3) dlog(9,"slave stopped (slave_recv closed)");
}

/////#############
void action_stop() { lf("action_stop"); set_state(12); d(0, "stopping"); slave_s("loadfile \"\"\n");
// if(last_type==2||last_type==12) wait_for_stop(slave_recv);
}
/////#############
void meta_unload() { lf("meta_unload"); clip_artist[0]=clip_title[0]=clip_album[0]=clip_year[0]
 =clip_genre[0]=clip_comment[0]=0; }



#define add_param(s) { param_list[i][c] = malloc(strlen(s)+1); strcpy(param_list[i][c++],s); }

// state: 0-uninited, 1-forked, 2-alive(stopped), 3-playing, 4-paused, 5-loading(sent to slave),
//        6-loading (slave reacted)


////############ Sets up comm sockets, forks a new process, and starts slave
int slave_init() { lf("slave_init");
 int type=-77; if(d_i[cur]) type=d_i[cur]->a2; if(type<1) return 0;
//TYPEWAV
 if(type>=19) type=2; // int ttype=type;
// if(type==12) type=2;

 int i,c; char lmsg[256];
 //if(state>0) return true;  set_state(0);
 //int just_init=1; //if(filename) just_init=0;
 i=1; c=0; if(param_list[i][0]==NULL) { add_param("uade123"); add_param("-Z"); add_param("-v");
  add_param("--detect-format-by-content");
  add_param("--timeout=130"); add_param("--enable-timeouts");
 }
// i=2; c=0; if(param_list[i][0]==NULL) { add_param(conf.mplayer_path); add_param("-slave");
//  add_param("-idle");
//  add_param("-quiet"); add_param("-msglevel"); add_param("global=9");
//  add_param("-framedrop"); add_param("-cache"); add_param("192"); // add_param("-nocache");
//  add_param("-vo"); add_param("null"); add_param("-vc"); add_param("null");
//  add_param("-ao"); add_param("alsa,oss,dsound,win32,null");
////  add_param("-af"); add_param("equalizer=-6:-3:0:-2:-6:-7.5:-4:0:+2:-1");
////   add_param("-geometry"); add_param("+1024+0"); add_param("-fs"); add_param("-zoom");
////   add_param("-af"); add_param("resample=22050");//   add_param("-srate"); add_param("22050");
////   add_param("-channels"); add_param("2");//   add_param("-af-adv"); add_param("force=2");
//// mplayer - -ac ffmp3 -ao pcm:nowaveheader:file=/dev/stdout -quiet -really-quiet | sox -t raw -r 44100 -e signed-integer -b 16 -c 2 - -t alsa compand .1,.3 9:-15,0,-9 -6 -90 .1 riaa pitch 600
// }
// i=12; c=0; if(param_list[i][0]==NULL) { add_param(conf.mplayer_path); add_param("-slave");
//  add_param("-idle"); add_param("-quiet");
//  add_param("-framedrop"); add_param("-cache"); add_param("256");
//  add_param("-vo"); add_param("null"); add_param("-vc"); add_param("null");
//  add_param("-ao"); add_param("alsa,oss,dsound,win32,null");
// }
// i=3; c=0; if(param_list[i][0]==NULL) { add_param("timidity-slave"); add_param("-idv");
//  add_param("--buffer-fragments=8,12");add_param("--audio-buffer=2,100");add_param("--polyphony=1024");
//  //add_param("--sampling-freq=32000");add_param("-EFreverb=0");add_param("-EFchorus=0");
//  add_param("slave");
// }
// i=4; c=0; if(param_list[i][0]==NULL) { add_param("xmp-slave"); }
// i=5; c=0; if(param_list[i][0]==NULL) { add_param("sidplay2-slave"); add_param("-t2:40"); add_param("slave"); }
// i=6; c=0; if(param_list[i][0]==NULL) { add_param("spcplayer-slave"); }
// i=7; c=0; if(param_list[i][0]==NULL) { add_param("nosefart-slave"); }
// i=8; c=0; if(param_list[i][0]==NULL) { add_param("fc14-slave"); }
// i=9; c=0; if(param_list[i][0]==NULL) { add_param("gme-slave"); }

 int fd_send[2], fd_recv[2], fd_recv2[2];
 if(socketpair(AF_UNIX, SOCK_STREAM, 0, fd_send) < 0) return false;
 if(socketpair(AF_UNIX, SOCK_STREAM, 0, fd_recv) < 0) return false;
 if(socketpair(AF_UNIX, SOCK_STREAM, 0, fd_recv2) < 0) return false;

 signal(SIGPIPE, SIG_IGN); signal(SIGCHLD, SIG_IGN); // Ignore signal for death of the child process

 last_type=type; sprintf(dmsg, "[fork, type: %d (%s)]", type, d_i[cur]->v);
if(0) {
 i=0; while(param_list[type][i]!=NULL) { strcat(dmsg," "); strcat(dmsg,param_list[type][i]); i++; }
 dlog(0,"d1");
 dlog(0,dmsg);
 dlog(0,"d2");
}

 vis=conf.vis;

 slave_pid = fork(); if(slave_pid == 0) // I am a child!
 { state=-7; // for dlog, state is otherwise unused in child
  sprintf(lmsg, "slave_init: i am child (%d, %s)", last_type, tn[last_type]); dlog(9,lmsg);

//  dup2(1, 2);  //redirects stderr to stdout below this line.

// pipe in/output through socket to parent
#if 1
// dup2(oldfd, newfd) makes newfd be the copy of oldfd, closing newfd first if necessary
  dup2(fd_send[0], STDIN_FILENO);
  dup2(fd_recv[0], STDOUT_FILENO);
//    dup2(fd_recv[0], STDERR_FILENO);
  dup2(fd_recv2[0], STDERR_FILENO);
  close(fd_send[1]); close(fd_recv[1]); close(fd_recv2[0]); close(fd_recv2[1]);
#endif

  parent_said=fd_send[0]; parent_ear=fd_recv[0];
  if(type==2 || type==12) { int ret=oscp_ffmpeg_main(); dlog(9,"ofm: type 2||12 (ffm): done");
   exit(ret);
  } else if(type==4) { int ret=oscp_xmp_main(); dlog(9,"ofm: type 4 (xmp): done"); exit(ret);
  } else if(type==5) { int ret=oscp_sid2_main(); dlog(9,"ofm: type 5 (sid2): done"); exit(ret);
  } else if(type==8) { int ret=oscp_fc14_main(); dlog(9,"ofm: type 8 (fc14): done"); exit(ret);
  } else if(type==9) { int ret=oscp_gme_main(); dlog(9,"ofm: type 9 (gme): done"); exit(ret);
  } else if(type==16) { int ret=oscp_asap_main(); dlog(9,"ofm: type 16 (asap): done"); exit(ret);
  } else if(type==17) { int ret=oscp_sc68_main(); dlog(9,"ofm: type 17 (sc68): done"); exit(ret);
  } else if(type==18) { int ret=oscp_mdx_main(); dlog(9,"ofm: type 18 (mdx): done"); exit(ret);
  } else if(type==3) { int ret=oscp_timi_main(); dlog(9,"ofm: type 3 (timi): done"); exit(ret);
  } else if(type>=1) {
   sprintf(lmsg, "[child, type: %d]", type); dlog(0,lmsg);
//TYPEWAV
   if(type>=19) {
    if(execvp(param_list[2][0],param_list[2])<0) { dlog(0,"slave_init: execvp failed (e1)"); }
   } else if(execvp(param_list[last_type][0],param_list[last_type])<0)
   { dlog(0,"slave_init: execvp failed (e2)"); }
  }
  dlog(0,"EOF code: slave_init: execvp failed");
  exit(-1);
 }

 // I am a parent!
 close(fd_send[0]); slave_send = fd_send[1];
 close(fd_recv[0]); slave_recv = fd_recv[1];
 close(fd_recv2[0]); slave_recv2 = fd_recv2[1];

 int ret=7;

 if(slave_pid==-1) { set_state(0); // child is dead
  if(slave_send>0) close(slave_send); if(slave_recv>0) close(slave_recv);
  if(slave_recv2>0) close(slave_recv2); slave_send=slave_recv=slave_recv2=-1; ret=false;
 } else { set_state(1); // child is alive
  buflen=0; setpriority(PRIO_PROCESS,slave_pid,-1); ret=true; }

//  sprintf(lmsg, "slave_init: i am child (%d, %s)", last_type, tn[last_type]); dlog(9,lmsg);
 sprintf(lmsg, "slave_init: i am parent (%d, %s) ret: %d, slave_pid: %d",
  last_type, tn[last_type], ret, slave_pid); dlog(9,lmsg);
 usleep(200000);  // wait a bit

 if(0) { i=0; while(i<10) { sprintf(lmsg, "loop, i=%d", i); d(9,lmsg);
  if(read(slave_recv, lmsg, 10)>0) { d(9,lmsg); }  usleep(50000); i++; } }

 return ret;
}
/////########### Closes comm lines and kills slave child process
void slave_end() { lf("slave_end"); if(slave_pid>1) { slave_s("quit\n"); usleep(200000);
  if(slave_send>0) close(slave_send); if(slave_recv>0) close(slave_recv);
  if(slave_recv2>0) close(slave_recv2); slave_send=slave_recv=slave_recv2=-1;
  if(kill(slave_pid,0)==0) { d(0,"Killing slave."); kill(slave_pid,SIGTERM); usleep(400000); }
  if(kill(slave_pid,0)==0) kill(slave_pid,SIGKILL);  slave_pid=0; set_state(0); last_type=-1;
 }
 state=0; set_noinfo();
}

////##################
int slave_s(char *msg) { lf2("slave_s",msg);
 if(state<=0 || slave_send<0) return 0; static char lmsg[4096], *t;
 int rc, l=strlen(msg);

 fd_set fdsw; struct timeval tv; tv.tv_sec=tv.tv_usec=0; FD_ZERO(&fdsw); FD_SET(slave_send, &fdsw);
 rc=select(FD_SETSIZE, NULL, &fdsw, NULL, &tv);
 if(rc<=0) { dlog(0,"slave_s: select rc<0, child died?"); return 0; }

 rc=write(slave_send, msg, l);
 sprintf(lmsg, "slave_s: (%d) %s", l, msg); t=index(lmsg, *"\n"); if(t) t[0]=*"N";
 dlog(0,lmsg);
 if(rc==0) dlog(0,"slave_s: rc==0, socket clogged?");
 if(rc<0) { dlog(0,"slave_s: rc<0, child died?"); }
 return rc;
}

#include <sys/types.h>
#include <unistd.h> //pread
////###############
int slave_r(int fd) { lfd("slave_r",fd); if(fd<0) { d(9, "slave_r: fd<0"); return 0; }
 static char srbuf[4096], lmsg[4096]; static int srr; int rc;
 buf[0]=0; buflen=0;

 while((rc=read(fd, buf+buflen, 1))>0) {
//sprintf(lmsg, "[slave_r: %c]", buf[buflen]); d(9, lmsg); // dlog(lmsg);
  if(buf[buflen]==0 || buf[buflen]=='\n' || buf[buflen]=='\r' || buflen>=bufsizee-1)
  { if(buflen==0) return 0;
//sprintf(lmsg, "[slave_r: fd:%d, buflen:%d, buf:%s]", fd, buflen, buf); dlog(lmsg);
   if(strncmp(srbuf, buf, buflen)!=0) {
    if(srr>1) { sprintf(lmsg, "[slave_r: last message repeated %d times (fd:%d, buflen:%d)]", srr, fd, buflen); dlog(0,lmsg); }
    srr=1; buf[buflen]=0; // sprintf(lmsg, "[slave_r: fd:%d, buflen:%d, buf:%s]", fd, buflen, buf); dlog(0,lmsg);
   } else { srr++; }

//    int i; for(i=0; i<strlen(srbuf); i++) { if(srbuf[i]=='\n') srbuf[i]='N';
//     if(srbuf[i]=='\r') srbuf[i]='R'; } srbuf[i]=0; strcpy(srbuf, buf); srbuf[buflen+1]=0;
   buf[buflen]=0;
if(conf.debug>=9) { sprintf(lmsg, "slave_r: (%d) %s", buflen, buf); dlog(9, lmsg); } // dlog(lmsg);
   return buflen;
  }  buflen+=rc;
} if(rc<=0) {
//  sprintf(lmsg, "[slave_r: rc:%d, fd:%d (recv:%d, recv2:%d)]", rc, fd, slave_recv, slave_recv2); dlog(0,lmsg);
  if(fd>0) close(fd); close(slave_send); close(slave_recv); close(slave_recv2);
  slave_send=slave_recv=slave_recv2=-1; slave_pid=-1;
  return rc;
 } else return 0; }

char wavtmpname[PM], wavcmd[128+PM];
void check_vfstmpname() { if(vfstmpname[0]!=0) unlink(vfstmpname); vfstmpname[0]=0; }

/////######################################################
void extract_file_zip(char *an, char *vq, char *vfstmpname) { lf("extract_file_zip");
 char buf[4096]; int br;
 ZZIP_DIR *d = zzip_dir_open(an,0); if(!d) {
  dlog(9, an); dlog(9, "extract_file_zip: zzip_dir_open failed"); return; }
 ZZIP_FILE *f=zzip_file_open(d, vq, 0); zzip_dir_close(d);
 if(!f) { dlog(9, vq); dlog(9, "extract_file_zip: zzip_dir_open failed"); return; }

 unlink(vfstmpname); FILE *f2=fopen(vfstmpname, "w");

 if(f && f2) { while((br=zzip_file_read(f, buf, 4096))>0) { fwrite(buf, br, 1, f2); } }
 if(f2) fclose(f2); else dlog(9, "extract_file_zip: cant open/write vfstmpname");
 if(f) zzip_file_close(f);
}

void action_next();
/////#############
void action_load() { lf("action_load");
 check_vfstmpname(); if(!d_i[cur] || d_i[cur]->a2<=0) return;
 if(d_i[cur]->v[0]==0) { usleep(100000); action_next(); return; }

 int type=d_i[cur]->a2, ttype=type; if(type>=19) type=2; //TYPEWAV

 if(type!=last_type || type==12) { slave_end(); slave_init(); }
// if(type==12) { type=2; } // force http[s] to be handled by mplayer, and reset it too

 set_state(5); set_totaltime(0);

 char lmsg[4096]; snprintf(lmsg, 4095, "Loading(%s): %s",
  tn[type], d_i[cur]->v2); d(0,lmsg);

 FILE *f2=fopen("/tmp/oscp-now-playing.txt","w");
 if(f2) { fwrite(d_i[cur]->v2, strlen(d_i[cur]->v2), 1, f2); fclose(f2); }

 strcpy(conf.file, d_i[cur]->v); char *namep=conf.file;
// snprintf(lmsg, 4095, "action_load: conf.file: %s", conf.file); dlog(9,lmsg);

 if(wavtmpname[0]!=0) { unlink(wavtmpname); wavtmpname[0]=0; }
 if(ttype>=19) { //TYPEWAV
  sprintf(wavtmpname, "/tmp/oscptmp-%s.wav", d_i[cur]->v1); unlink(wavtmpname); }

 // handle archives: /1/osc/oscp/mods/mods.zip#zip#/##_mochoom_##.mod
 char *t=strstr(d_i[cur]->v, "#/"), *t2;
 if(t) { if(strlen(t)<3) return;
  if(t-d_i[cur]->v<4) return;
  if(index(t, *"\\") || index(t, *"\"")) return;

  int atype=0;
       if(strncmp(t-4, "#zip#", 5)==0) atype=-3;
  else if(strncmp(t-4, "#rar#", 5)==0) atype=-4;
  else { dlog(9,"action_load: unknown archive scheme"); return; }
  t+=2;

  char cmd[PM*2], an[PM]; cmd[0]=0;
  strcpy(an, d_i[cur]->v); t2=strstr(an, "#/");
  if(t2 && t2>an) { t2[0]=0; t2=rindex(an, *"#"); if(t2 && t2>an) t2[0]=0; }

  sprintf(vfstmpname, "/tmp/oscptmp-%s", d_i[cur]->v1); unlink(vfstmpname);
  static char vq[PM]; int i,j=0;
  for(i=0; i<=strlen(t); i++) { if(t[i]==*"\"") { vq[j]=*"\\"; j++; vq[j]=t[i]; }
   else vq[j]=t[i]; j++; } vq[j]=0;
  switch(atype) {
   case -3:
// sprintf(cmd, "unzip -p \"%s\" \"%s\" > \"%s\" 2>>/tmp/oscp.err", an, vq, vfstmpname);
    extract_file_zip(an, vq, vfstmpname);
    break;
   case -4: sprintf(cmd, "unrar p -p- -c- -cfg- -inul \"%s\" \"%s\" > \"%s\" 2>>/tmp/oscp.err", an, vq, vfstmpname); break;
  } // -idc (copyright) -idd (done) -idp (percentage) -idq (informational)
//  dlog(9,cmd);
  if(cmd[0]!=0) system(cmd);
  namep=vfstmpname;
 }

 set_noinfo(); meta_unload(); if(ttype==2) get_id3v2(conf.file); draw_clip_shortinfo();
// if(type==2 && index(namep, *"\"")!=NULL) { namep[0]=0; } // protect against "

 if(ttype>=19) { //TYPEWAV
  unlink(wavtmpname);
  if(0&&ttype==16) { sprintf(wavcmd, "asapconv -o \"%s\" \"%s\"", wavtmpname, namep);
   dlog(0,wavcmd);  system(wavcmd); }
  if(0&&ttype==17) { FILE *f; if((f=fopen(wavtmpname, "w"))==NULL) dlog(0,strerror(errno));
   // wav header
   long fs=0; char wh[48]="\x52\x49\x46\x46\x24\x20\x13\x01\x57\x41\x56\x45\x66\x6D\x74\x20\x10\x00"
   "\x00\x00\x01\x00\x02\x00\x44\xAC\x00\x00\x10\xB1\x02\x00\x04\x00\x10\x00\x64\x61\x74\x61\x00"
   "\x02\x13\x01";  fseek(f, 0, SEEK_SET); fwrite(wh, 44, 1, f);
   sprintf(wavcmd, "sc68 -c --sc68-skip-time=16 -l 1 \"%s\" 2>>/tmp/oscp.err | dd 2>>/tmp/oscp.err bs=4k count=160k >> \"%s\"", namep, wavtmpname);
   dlog(0,wavcmd);  system(wavcmd);
   freopen(wavtmpname, "r+b", f); fseek(f, 0, SEEK_END); fs=ftell(f)-44; fseek(f, 40, SEEK_SET);
   // update wav header length
   fwrite((char *)&fs, 4, 1, f); fclose(f);
  }
  // 600M == 60min, 60M=6min, 30M=3min, 4k 8k==0:08,  4k 160k==2:40
  if(ttype==18) { sprintf(wavcmd,
    "mdxplay 2>>/tmp/oscp.err -s -l 1 \"%s\" | dd 2>>/tmp/oscp.err bs=4k count=160k > \"%s\"",
    namep, wavtmpname);
   dlog(0,wavcmd);  system(wavcmd);
  }
//  sprintf(dmsg, "loadfile \"%s\"\n", wavtmpname);  //usleep(10000000);
  sprintf(dmsg, "loadfile %s\n", wavtmpname);  //usleep(10000000);
 } else if(last_type==2 || last_type==12) {
// #ifdef CYGWIN
// char namewin[4096];  namC2W(namewin, namep);  namep=namewin;
// #endif
//  sprintf(dmsg, "loadfile \"%s\"\n", namep);
  sprintf(dmsg, "loadfile %s\n", namep);
 } else {
  sprintf(dmsg, "loadfile %s\n", namep);
 }

 slave_s(dmsg);
 draw_list();
}
// 00000000 52 49 46 46 | 24 20 13 01 | 57 41 56 45 | 66 6D 74 20 | 10 00 00 00 | 01 00 02 00  RIFF$ ..WAVEfmt ........
// 00000018 44 AC 00 00 | 10 B1 02 00 | 04 00 10 00 | 64 61 74 61 | 00 20 13 01 |              D.........data. ..

/////##############
void action_enter() { lf("action_enter"); if(dmt<=0) { d(0,"[list empty]"); return; }
 cur=pos;
 char tmp[128]; sprintf(tmp, "action_enter: type:%d", d_i[cur]->a2); dlog(0,tmp);
 switch(d_i[cur]->a2) {
  case -4: case -3: case -2: top=pos=0; load_vdir(d_i[cur]->v); break;
  case -1: top=pos=0; load_dir(d_i[cur]->v); break;
  default: action_load(); break;
 }
 draw_list(); }
/////#############
void action_play() { lf("action_play"); action_enter(); }
/////#############
void action_next() { lf("action_next");
 if(conf.shuffle==1) { int i=100, o=cur; do { --i; cur=rr(0,dmt-1); } while(i>0
  && (o==cur || d_i[cur]->a2<=0)); action_load(); scrollto(cur); return; }

 if(conf.repeat) { // find next playable entry, but rescan list only once
  cur++; if(cur>=dmt) { cur=0; }
  while(d_i[cur]->a2<=0 && cur<dmt) ++cur;
  if(cur<dmt) { action_load(); scrollto(cur); } else action_stop();
 } else if(cur<dmt-1) { cur++; action_load(); scrollto(cur); } else action_stop(); }
/////#############
void action_prev() { lf("action_prev"); if(conf.shuffle==1) { action_next(); return; }
 if(conf.repeat) { --cur; if(cur<0) cur=dmt-1; action_load(); }
 else if(cur>0) { --cur; action_load(); } else action_stop(); }
/////##################
void action_seek(int a) { lfd("action_seek", a); if(a<0) return;
 char lmsg[40]; sprintf(lmsg, "seek %d 0\n", a); slave_s(lmsg); }
/////#############
void action_rwnd() { lf("action_rwnd"); slave_s("seek -15 0\n"); }
//void action_rwnd() { if(d_i[cur]->a2>0) slave_s("seek -15 0\n"); else slave_s("z\n"); }
/////#############
void action_ffwd() { lf("action_ffwd"); slave_s("seek +15 0\n"); }
//void action_ffwd() { if(d_i[cur]->a2>0) slave_s("seek +15 0\n"); else slave_s("b\n"); }
/////##############
void action_pause() { lf("action_pause"); set_state(14); slave_s("pause\n"); }

/////####################
void action_copy_to_fav() { lf("action_copy_to_fav");
 if(conf.favsavepath[0]==0) { d(0, "favsavepath undefined"); return; }
 char lmsg[4096]; ds(0, "copied to fav", d_i[pos]->v1);
 sprintf(lmsg, "exec >>/tmp/oscp-c2f.log 2>&1; set -x; cp \"%s\" \"%s\" &\n",
  d_i[pos]->v, conf.favsavepath);  system(lmsg);
}

int c_get_key();
/////####################
void action_delete_file() { lf("action_delete_file");
// char lmsg[128]; snprintf(lmsg, 127, "adf: top: %d, pos: %d", top, pos); dlog(9,lmsg);
 bli *c=d_i[pos]; if(c->v[0]==0) return;
 ds(0, "delete_file? (y/N)", c->v2);
 int k=c_get_key(), r=0;
 if(k==*"y") { r=unlink(c->v);
  c->v[0]=0; c->v1[0]=0; c->v2[0]=0; draw_list();
  if(r==0) { d(0, "delete OK"); usleep(1500000); if(pos==cur)action_next(); }
  else { d(0, "delete ERR"); usleep(1500000); }
 }
 draw_clip_shortinfo(); refresh();
}

////########
int get_ch() { lf("get_ch"); int ch;
 fd_set fdsr; struct timeval tv; fflush(stdin);
 tv.tv_sec=tv.tv_usec=0; FD_ZERO(&fdsr); FD_SET(0, &fdsr); // stdin file descriptor
 if(select(FD_SETSIZE, &fdsr, NULL, NULL, &tv) == 1)
 { ch = getch();
 //mvprintw(lines-3,70,"(%3d)", ch); refresh(); //sleep(1);
 } else ch = (chtype) ERR;
 return(ch);
}

////###########
int c_get_key() { lf("c_get_key"); int key=getchar(); // dd(0,"K",key);refresh();usleep(2000000);
      if(key==13) key=-16;
 else if(key==KEY_RESIZE) dlog(9, "KEY_RESIZE");
 else if(key==27) { int i=0; char string[16]; string[0]=0;
   do { i++; key=getchar(); if(key!=-1) strcat(string, (char *)&key); }
    while(i<16 && key!=*"~" && (key==*"O" || key<*"A" || key>*"Z")); // && key!=*"\\" && key!=*"?"

        if(!strcmp(string,"[A") || !strcmp(string,"OA") || !strcmp(string,"[11~")) key=-18; // up
   else if(!strcmp(string,"[B") || !strcmp(string,"OB") || !strcmp(string,"[12~")) key=-12; // down
   else if(!strcmp(string,"[C") || !strcmp(string,"OC") || !strcmp(string,"[13~")) key=-16; // right
   else if(!strcmp(string,"[D") || !strcmp(string,"OD")                          ) key=-14; // left
   else if(!strcmp(string,"[5~")) key=-19; // pgup
   else if(!strcmp(string,"[6~")) key=-13; // pgdown
   else if(!strcmp(string,"[7~") || !strcmp(string,"[H") || !strcmp(string,"OH")) key=-17; // home
   else if(!strcmp(string,"[8~") || !strcmp(string,"[F") || !strcmp(string,"OF")) key=-11; // end
   else if(!strcmp(string,"[2~")) key=-21; // insert
   else if(!strcmp(string,"[3~")) key=-22; // del
   else if(!strcmp(string,"[P")) key='P';
//   else if(!strcmp(string,"\\")) { key=0; print_screen(); }
//  else
  if(conf.debug>0) { mvprintw(conf.lines-4,2,"-[ %s ]------", string); refresh(); }
// ds(0,"s", string);
// usleep(3000000);
 }

#if 0
 int i; char khs[128]; static int kh[8];
 memmove(kh+1, kh, 7*4); kh[0]=key; for(i=0; i<8; i++) { sprintf(khs+i*6, "% 6d", kh[i]); }
 ds(0, "kh", khs); refresh(); // usleep(300000);
#endif

 return key;
}

/////###########################
void toggle_timeremaining_mode() { lf("toggle_timeremaining_mode");
 conf.timeremaining_mode=!conf.timeremaining_mode; draw_elapsedtime(); }

/////#########################
void load_dir_or_vdir(char *a) { lf2("load_dir_or_vdir",a);
 FILE *f; DIR *d; d=opendir(a); if(d) { closedir(d); load_dir(a); }
 else { f=fopen(a, "r"); if(f) { fclose(f); load_vdir(a); } } }

/////##################
void check_key(int key) { lfd("check_key",key);
 if(key==*"q") { conf.quit=1; }
 else if(key==-18) { action_up(); }
 else if(key==-12) { action_down(); }
 else if(key==-19) { action_pgup(); }
 else if(key==-13) { action_pgdn(); }
 else if(key==-17) { action_home(); }
 else if(key==-11) { action_end(); }
 else if(key==-14) { top=pos=0; action_enter(); } // go to parent dir
 else if(key==-16) { action_enter(); }
 else if(key==-21) { action_copy_to_fav(); }
 else if(key==-22) { action_delete_file(); }
 else if(key==*"p") { action_pause(); }
 else if(key==*"[") { action_prev(); }
 else if(key==*"]") { action_next(); }
 else if(key==*" ") { action_next(); }
 else if(key==*",") { action_rwnd(); }
 else if(key==*".") { action_ffwd(); }
 else if(key==*"e") { toggle_eias(); }
 else if(key==*"s") { toggle_shuffle(1); }
 else if(key==*"S") { toggle_shuffle(2); }
 else if(key==*"r") { toggle_repeat(); }
 else if(key==*"t") { toggle_timeremaining_mode(); }
 else if(key==*"f") { toggle_fullpath(); }
 else if(key==*"v") { toggle_vis(); }
 else if(key==*"i") { draw_clip_info(); }
 else if(key==*";") { make_recursive_list(NULL,0); }
 else if(key==*"-") { chvol(-3); draw_volume(); }
 else if(key==*"=") { chvol(+3); draw_volume(); }
 else if(key==*"\\") { action_stop(); }
 else if(key==*"0") { load_dir_or_vdir(conf.udir[0]); }
 else if(key==*"1") { load_dir_or_vdir(conf.udir[1]); }
 else if(key==*"2") { load_dir_or_vdir(conf.udir[2]); }
 else if(key==*"3") { load_dir_or_vdir(conf.udir[3]); }
 else if(key==*"4") { load_dir_or_vdir(conf.udir[4]); }
 else if(key==*"5") { load_dir_or_vdir(conf.udir[5]); }
 else if(key==*"6") { load_dir_or_vdir(conf.udir[6]); }
 else if(key==*"7") { load_dir_or_vdir(conf.udir[7]); }
 else if(key==*"8") { load_dir_or_vdir(conf.udir[8]); }
 else if(key==*"9") { load_dir_or_vdir(conf.udir[9]); }

 else if(key==*"d") { lfdump(); }
 else if(key==*"D") { slave_s("lfdump\n"); }
 else if(key==*"m") { slave_s("trigger 1\n"); }
 else if(key==*"M") { slave_s("trigger 2\n"); }

// else dd(0,"k", key);

 else if(key==*"/") { scrollto(dmt-1); }
}
int frame=0, slave_inits=0;
/////#############
void slave_parse() { lf2("slave_parse",buf); if(buf[0]==0) { d(1, "[slave said nothing?]"); return; }
// dlog(0,"[slave_parse]"); dlog(0,buf);

 char *c1, *c2; strcpy(buf_tmp, buf); int buf_len=strlen(buf_tmp);
 c1=strtok(buf, " \t"); if(!c1) return;

 if(strncmp(buf_tmp,"ANS_time_pos=",13)==0)
 { int curtime=atoi(buf_tmp+13); if(state!=3) set_state(3);
   set_elapsedtime(curtime,last_totaltime-curtime); //set_totaltime(last_totaltime);
 }

 if(strncmp(buf_tmp,"ANS_TIME_POSITION=",18)==0)
 { int curtime=atoi(buf_tmp+18); if(state!=3) set_state(3);
   set_elapsedtime(curtime,last_totaltime-curtime); //set_totaltime(last_totaltime);
 }

 else if(strncmp(buf_tmp,"ANS_length=",11)==0)
 { last_totaltime=atoi(buf_tmp+11); set_totaltime(last_totaltime); }

 else if(strncmp(buf_tmp,"ANS_ERROR=PROPERTY_UNAVAILABLE",30)==0)
 { if(state==3 || state==6) action_next(); }

//audio only: A:3659.5 ( 1:00:59.5) of 0.0 (unknown)  2.3% 18%
//a-v:        A:   0.0 V:   0.0 A-V:  0.002 ct:  0.000   0/  0 ??% ??% ??,?% 0 0 73%
 else if(!strncmp(buf_tmp, "A:",2))    // audio stream time info
 { int curtime; float tmp; sscanf(buf_tmp+2,"%f", &tmp); curtime=(int)(tmp);
   if(index(buf_tmp,*"f")) { sscanf(index(buf_tmp,*"f")+1,"%f", &tmp); last_totaltime=(int)(tmp);
    set_totaltime(last_totaltime);
   }
   if(state!=3) set_state(3);
   set_elapsedtime(curtime,last_totaltime-curtime);
 }

 else if(strcmp(c1,"MPlayer")==0 || strcmp(c1,"oscp-slave")==0) {
  set_state(2); slave_inits++; c2=c1?strtok(NULL,""):NULL;
  sprintf(dmsg,"Decoder '%s' '%s' started (#%d).",c1,c2,slave_inits); dlog(0,dmsg);
  // d(0, dmsg);
 }

/*
A: 3.2 0 0 0 0 0 0 0

Title: ./2.mod
Album: PTK-Prowiz, 100766 bytes
AUDIO: 48000 Hz, 2 ch, xxx, 1536 kbit
A: 0.0 0 0 0 0 0 0 0
*/

 else if(strncmp(c1, "AUDIO:",6)==0) // It's song info
 {
  if(d_i[cur]->a2==1 && state==5) set_state(6);
  set_state(3);
// 1.0-SVN-r24577   AUDIO: 22050 Hz, 2 ch, s16le, 8.0 kbit/1.13% (ratio: 1000->88200)
// SVN-r35058-4.7.1 AUDIO: 44100 Hz, 2 ch, floatle, 128.0 kbit/4.54% (ratio: 16000->352800)
  c2=c1?strtok(NULL," \t"):NULL; freq=atoi(c2);
  c2=c2?strtok(NULL," \t"):NULL; // Hz,
  c2=c2?strtok(NULL," \t"):NULL; chan=atoi(c2);
  c2=c2?strtok(NULL," \t"):NULL; // ch,
  c2=c2?strtok(NULL," \t"):NULL; // s16be,
  c2=c2?strtok(NULL," \t"):NULL; bitrate=atoi(c2);
  draw_format();
//TYPEWAV
//  if(d_i[cur]->a2==2 || d_i[cur]->a2>=19) slave_s("get_property length\n");
 }

 else if(strcmp(c1, "=====")==0)
 { c2=c1?strtok(NULL," \t"):NULL; if(c2) {
  if(strcmp(c2, "PAUSE")==0) set_state(4);
  else if(strcmp(c2, "RESUME")==0) set_state(6);
 } }

 else if(strcmp(c1, "Paused.")==0) { set_state(4); }

 else if(strcmp(c1, "Playing")==0) { set_state(6); }

 else if(strcmp(c1, "Loaded.")==0) { memset(clip_comment,*" ",127); set_state(6); }

 else if(!strncmp(buf_tmp, "Lyr: ",5)) { int ll=strlen(buf_tmp)-5; if(ll>0) {
   ++ll; if(ll>127) ll=127;
   char *t=clip_comment;
   memmove(t, t+ll, 128-ll);
   t[127-ll]=*"|";
   --ll;
   memcpy(t+127-ll, buf_tmp+5, ll); t[127]=0;
   strcpy(clip_title, t+127-conf.cols+6);
   draw_clip_shortinfo();
//   trim(buf_tmp+5);
//   if(strlen(buf_tmp+5)>0) strcpy(clip_title, buf_tmp+5);
  }
 }

 else if(!strncmp(buf_tmp, "Name   :",8)) { if(buf_len>9) { trim(buf_tmp+9);
  if(strlen(buf_tmp+9)>0) strcpy(clip_title, buf_tmp+9); } draw_clip_shortinfo(); }

 else if(!strncmp(buf_tmp, "Title:",6)) { if(buf_len>7) { trim(buf_tmp+7);
  if(strlen(buf_tmp+7)>0) strcpy(clip_title, buf_tmp+7); } draw_clip_shortinfo(); }

 else if(!strncmp(buf_tmp, "Sequence:",9)) { if(buf_len>9) { trim(buf_tmp+9);
  if(strlen(buf_tmp+9)>0) strcpy(clip_title, buf_tmp+9); } draw_clip_shortinfo(); }

//ICY Info: StreamTitle='some title';
 else if(!strncmp(buf_tmp, "ICY Info: StreamTitle=",22)) { if(buf_len>22) { trim(buf_tmp+22);
  if(strlen(buf_tmp+27)>0) strcpy(clip_title, buf_tmp+22); } draw_clip_shortinfo(); }

 else if(!strncmp(buf_tmp, "Artist:",7)) { if(buf_len>8) { trim(buf_tmp+8);
  if(strlen(buf_tmp+8)>0) strcpy(clip_artist, buf_tmp+8); } draw_clip_shortinfo(); }

 else if(!strncmp(buf_tmp, "Comment: ",9)) { if(buf_len>9) { trim(buf_tmp+9);
  if(strlen(buf_tmp+9)>0) strcpy(clip_comment, buf_tmp+9); } draw_clip_shortinfo(); }

 else if(!strncmp(buf_tmp, "Genre  :",8) || !strncmp(buf_tmp, "Website:",8)) {
  if(buf_len>9) { trim(buf_tmp+9);
  if(strlen(buf_tmp+9)>0) strcpy(clip_genre, buf_tmp+9); } draw_clip_shortinfo(); }

 else if(!strncmp(buf_tmp, "Album: ",7)) { if(buf_len>7) { trim(buf_tmp+7);
  if(strlen(buf_tmp+7)>0) strcpy(clip_album, buf_tmp+7); } draw_clip_shortinfo(); }

 else if(!strncmp(buf_tmp, "Year: ",6)) { if(buf_len>6) { trim(buf_tmp+6);
  if(strlen(buf_tmp+6)>0) strcpy(clip_year, buf_tmp+6); } draw_clip_shortinfo(); }

// [dlog 1363605331, [slave_r: fd:11, buf:Module name: wizardry]]
 else if(!strncmp(buf_tmp, "Module name: ",13)) { if(buf_len>13) { trim(buf_tmp+13);
  if(strlen(buf_tmp+13)>0) strcpy(clip_title, buf_tmp+13); } draw_clip_shortinfo(); }

// [dlog 1363604802, [slave_r: fd:11, buf:subsong: 1 from range [1, 1]]]
 else if(strncmp(c1, "subsong:",8)==0) // subsong info
 { int subs, maxs;
  c2=c1?strtok(NULL," \t"):NULL; subs=atoi(c2);
  c2=c2?strtok(NULL," \t"):NULL; // from
  c2=c2?strtok(NULL," \t"):NULL; // range
  c2=c2?strtok(NULL," \t"):NULL; // [x,
  c2=c2?strtok(NULL," \t"):NULL; maxs=atoi(c2);
  sprintf(clip_year, "%d/%d", subs, maxs); draw_clip_shortinfo();
 }

// [dlog 1363607622, [slave_r: fd:11, buf:Changing to subsong 5 from range [1, 37]]]
 else if(strncmp(buf_tmp, "Changing to subsong ",20)==0) // subsong info
 { int subs, maxs;
  c2=c1?strtok(NULL," \t"):NULL; // to
  c2=c2?strtok(NULL," \t"):NULL; // subsong
  c2=c2?strtok(NULL," \t"):NULL; subs=atoi(c2);
  c2=c2?strtok(NULL," \t"):NULL; // from
  c2=c2?strtok(NULL," \t"):NULL; // range
  c2=c2?strtok(NULL," \t"):NULL; // [x,
  c2=c2?strtok(NULL," \t"):NULL; maxs=atoi(c2);
  sprintf(clip_year, "%d/%d", subs, maxs); draw_clip_shortinfo();
 }


 else if(strncmp(buf_tmp, "EOF code: exit",14)==0) // child exiting
 { slave_end(); set_noinfo(); slave_init(); }

 else if(strncmp(buf_tmp, "EOF code: stop requested",24)==0) // child stopped
 { state=2; set_noinfo(); }

 else if(strncmp(buf_tmp, "EOF code:",8)==0) // it's an end of file from slave (mplayer)
 { switch(state) {
   case 5: break; // ignore eof's if we sent load request
   case 12: state=2;
   case 2: set_noinfo(); d(0, buf_tmp); break;
   default: state=2; set_noinfo(); d(0, buf_tmp); action_next(); break;
 }}

 /* if(buf_len>9 && buf_tmp[10]==*"2") d("EOF received: 2"); else
        { seos(); clearname(); interface->set_filename("EOF received");
          interface->set_playstate(STOPPED); */
 else if(strncmp(buf_tmp, "[file]",6)==0) // [file] File size is 0 bytes
 { int size=-1;
  c2=c1?strtok(NULL," \t"):NULL; // File
  c2=c2?strtok(NULL," \t"):NULL; // size
  c2=c2?strtok(NULL," \t"):NULL; // is
  c2=c2?strtok(NULL," \t"):NULL; size=atoi(c2);
  if(size<=0) { set_noinfo(); dd(0, "File size:", size); action_next(); }
 }

 else if( (strncmp(buf_tmp, "VU: ",4)==0) ) // vu meter
 {
    mvaddch(conf.lines-4, 2, ' '|COLOR_PAIR(4)|conf.style[4]);
    mvaddnstr(conf.lines-4, 3, buf_tmp+3, conf.cols-6);
    int c; for(c=3+strlen(buf_tmp+3); c<conf.cols-2; c++)
     mvaddch(conf.lines-4, c, ' '|COLOR_PAIR(4)|conf.style[4]);
//   mvchgat(conf.lines-4, 5, conf.cols-7, conf.style[4], 4, NULL);
    refresh(); }

 else if( (strncmp(buf_tmp, "Info: ",6)==0) ) // It's info
 { if(conf.debug>0) {
    mvaddch(conf.lines-4, 2, ' '|COLOR_PAIR(4)|conf.style[4]);
    mvaddnstr(conf.lines-4, 3, buf_tmp+6, conf.cols-6);
    int c; for(c=3+strlen(buf_tmp+6); c<conf.cols-2; c++)
     mvaddch(conf.lines-4, c, ' '|COLOR_PAIR(4)|conf.style[4]);
//   mvchgat(conf.lines-4, 5, conf.cols-7, conf.style[4], 4, NULL);
    refresh(); } }

 else if( (strncmp(buf_tmp, "Failed to open",14)==0 && strncmp(buf_tmp+14," LIRC",5)!=0)
  || strncmp(buf_tmp, "Connect error",13)==0
  || strncmp(buf_tmp, "connect error: Connection refused",33)==0
  || !strncmp(buf_tmp, "Unknown format: ",16)
  || !strncmp(buf_tmp, "Unrecognized file format",24)
  || !strncmp(buf_tmp, "Error opening: ",15)
  || !strncmp(buf_tmp, "Error: ",7)
 ) // It's stream error/end
 { d(0,buf_tmp); if(state!=12) { usleep(500000); action_next(); } }

// else if( (strncmp(buf_tmp, "Failed to open",14)==0) && strcmp(buf_tmp+14," .")!=0 )
// { d(0,buf_tmp); sleep(1); action_next(); }

// else { d(0,buf_tmp); }
}

#include <sys/socket.h>
#include <sys/un.h>
int lirc_fd; char lirc_buf[128]; struct sockaddr_un lirc_addr;
int lirc_i;

/////###########
void lirc_init() { lf("lirc_init");
 lirc_addr.sun_family = AF_UNIX;
 strcpy(lirc_addr.sun_path, "/var/run/lirc/lircd");
 //strcpy(lirc_addr.sun_path, argv[optind]);
 lirc_fd = socket(AF_UNIX, SOCK_STREAM, 0);
 if(lirc_fd == -1) { perror("lircd setup failed"); } else {
  if(connect(lirc_fd, (struct sockaddr *)&lirc_addr, sizeof(lirc_addr)) == -1) {
   char lmsg[256];
   snprintf(lmsg, 255, "lircd socket connect failed: (%d) %s", errno, strerror(errno));
   dlog(9,lmsg);
//   perror("lircd socket connect failed");
   lirc_fd=-1;
  }
 }
}

#include <sys/wait.h>
int say_inited=0;
/////#############################
void zombieHandler(int signal_num) // wait for the child process and clean up
{ lf("zombieHandler"); int status; wait(&status); }
/////##########
void say_init() { lf("say_init");
 struct sigaction sa; memset(&sa, 0, sizeof sa);
 sa.sa_handler = &zombieHandler;
 sigaction(SIGCHLD, &sa, NULL);
 say_inited=1;
}
/////###############
void say(char *what) { lf("say"); pid_t pid; //int status;
 if(say_inited==0) return; //say_init();
 signal(SIGCHLD, SIG_IGN);
 char *command="/usr/local/bin/espeak";
 pid = fork();
 if(pid == 0) { // This is the child process.  Execute the shell command.
  close(1); close(2); execl (command, command, "-p", "40", "-s", "150", "-g", "8", what, NULL); _exit(0);
 }
// else if (pid < 0) status = -1; // The fork failed.  Report failure.
// else // This is the parent process.  Wait for the child to complete.
// if (waitpid (pid, &status, 0) != pid) status = -1; return status;
// else say_init();
}
/////############
char lirc_parse() { lf("lirc_parse"); int lirc_i; if(lirc_fd<0) return 0;
// 00000014749f0000 00 right x10
 lirc_i=read(lirc_fd, lirc_buf, 128);
 if(lirc_i==-1) { lirc_fd=-1; return 0; }
 if(lirc_i==0) { lirc_fd=-1; return 0; }
 char id[32], key_name[16], remote_name[32]; unsigned int irepeat;
 sscanf(lirc_buf, "%31s %x %15s %31s", id, &irepeat, key_name, remote_name);
char lmsg[1024]; snprintf(lmsg, 1023, "lirc_parse: %s (%s)", key_name, remote_name); dlog(9,lmsg);
 if(!strcmp(key_name, "KEY_POWER")) return *"q";
 if(!strcmp(key_name, "KEY_UP")) return -18;
 if(!strcmp(key_name, "KEY_DOWN")) return -12;
 if(!strcmp(key_name, "KEY_CHANNELUP")) return -19;
 if(!strcmp(key_name, "KEY_CHANNELDOWN")) return -13;
 if(!strcmp(key_name, "KEY_LEFT")) return -14;
 if(!strcmp(key_name, "KEY_RIGHT")) return -16;
 if(!strcmp(key_name, "KEY_OK")) return -16;
 if(!strcmp(key_name, "KEY_PREVIOUS")) return *"[";
 if(!strcmp(key_name, "KEY_NEXT")) return *"]";
 if(!strcmp(key_name, "KEY_BLUE")) return *"[";
 if(!strcmp(key_name, "KEY_GREEN")) return *"]";
 if(!strcmp(key_name, "KEY_#")) { if(conf.shuffle==0) say("shuffle"); else say("shuffle off");
  return *"s"; }
 if(!strcmp(key_name, "KEY_*")) { if(conf.repeat==0) say("repeat"); else say("repeat off");
  return *"r"; }
 if(!strcmp(key_name, "KEY_REWIND")) return *",";
 if(!strcmp(key_name, "KEY_FASTFORWARD")) return *".";
 if(!strcmp(key_name, "KEY_RED")) return *",";
 if(!strcmp(key_name, "KEY_YELLOW")) return *".";
 if(!strcmp(key_name, "KEY_VOLUMEDOWN")) return *"-";
 if(!strcmp(key_name, "KEY_VOLUMEUP")) return *"=";
 if(!strcmp(key_name, "KEY_PLAY")) return -16;
 if(!strcmp(key_name, "KEY_PAUSE")) return *"p";
 if(!strcmp(key_name, "KEY_STOP")) { say("stop"); return *"\\"; }
 if(!strcmp(key_name, "KEY_TEXT")) { char tmp[1024], *p=d_i[cur]->v2; int i, l=strlen(p);
  if(l>1022) l=1022; if(l>4) l-=4; // poor man extension cutter
  for(i=0;i<l;i++) { if(
   (p[i]>=97 && p[i]<=122)	// a-z
 ||(p[i]>=65 && p[i]<=90)	// A-Z
//||(p[i]>=48 && p[i]<=57)	// 0-9
   ) tmp[i]=p[i]; else tmp[i]=32;
  } tmp[i]=0; say(tmp); return 0; }
 // trigger 1, right now only used to change midi patchset:
 if(!strcmp(key_name, "KEY_EPG")) { return *"m"; }
 if(!strcmp(key_name, "KEY_0")) return *"0";
 if(!strcmp(key_name, "KEY_9")) return *"9";
 if(!strcmp(key_name, "KEY_8")) return *"8";
 if(!strcmp(key_name, "KEY_7")) return *"7";
 if(!strcmp(key_name, "KEY_6")) return *"6";
 if(!strcmp(key_name, "KEY_5")) return *"5";
 if(!strcmp(key_name, "KEY_4")) return *"4";
 if(!strcmp(key_name, "KEY_3")) return *"3";
 if(!strcmp(key_name, "KEY_2")) return *"2";
 if(!strcmp(key_name, "KEY_1")) return *"1";
 else return 0;
}

int oscpslave_fd=0;
/////################
void oscpslave_init() { lf("oscpslave_init"); unlink("/tmp/oscp.slave");
 oscpslave_fd=open("/tmp/oscp.slave", O_RDWR | O_TRUNC | O_CREAT, S_IWOTH);
 if(oscpslave_fd>0) { fchmod(oscpslave_fd, S_IRUSR|S_IWUSR|S_IWGRP|S_IWOTH); }
}
/////#################
void oscpslave_check() { lf("oscpslave_check"); if(oscpslave_fd<=0) return;
 char buf[512]; lseek(oscpslave_fd, 0, SEEK_SET); if(read(oscpslave_fd, buf, 510)<=0) return;
 buf[511]=0;
 if(strncmp(buf, "next", 4)==0) action_next();
 else if(strncmp(buf, "prev", 4)==0) action_prev();
 else if(strncmp(buf, "playpause", 9)==0) action_pause();
 else if(strncmp(buf, "pause", 5)==0) action_pause();
 else if(strncmp(buf, "play", 4)==0) action_play();
 else if(strncmp(buf, "stop", 4)==0) action_stop();
 ftruncate(oscpslave_fd, 0);
}

int last_pos_ts=0;
/////############# check stdin & slave
void check_input() { lf("check_input");
 int key, i, rc; fd_set fsa, fsr; struct timeval tv, *tvp=NULL; tv.tv_sec=0; tv.tv_usec=10000*99;
 if(state==3 && d_i[cur] && (d_i[cur]->a2==2 || d_i[cur]->a2>=19)) tvp=&tv; //TYPEWAV

 i=(int)time(NULL);
// if(state==3 && (d_i[cur]->a2==2 || d_i[cur]->a2==12) && i!=last_pos_ts)
// { last_pos_ts=i; slave_s("get_time_pos\n"); }

 usleep(10000); FD_ZERO(&fsr); FD_ZERO(&fsa); FD_SET(STDIN_FILENO, &fsa);
 if(lirc_fd>0) FD_SET(lirc_fd, &fsa);
 if(oscpslave_fd>0) { if(lseek(oscpslave_fd, 0, SEEK_END)>0)
  { lseek(oscpslave_fd, 0, SEEK_SET); FD_SET(oscpslave_fd, &fsa); } }
 if(slave_recv>0) FD_SET(slave_recv, &fsa);
 if(slave_recv2>0) FD_SET(slave_recv2, &fsa);
char lmsg[1024]; 
//sprintf(lmsg, "slave_recv: %d, %d", slave_recv, slave_recv2); dlog(8, lmsg);

 frame++; rc=select(FD_SETSIZE, &fsa, NULL, NULL, tvp); // block till input

 const int lmsgd=1;
// sprintf(lmsg, "[check_input:select: frame:%d, rc:%d (%d,%d)]", frame, rc
//  , slave_recv, slave_recv2); dlog(0,lmsg);
 if(rc<0) { snprintf(lmsg, 1023, "check_input: rc<0, %s", strerror(errno)); dlog(9,lmsg); }
 else if(rc==0) {
//TYPEWAV
//  if( (d_i[cur]->a2==2 || d_i[cur]->a2>=19) && tv.tv_usec<=0) slave_s("get_property time_pos\n");
 } else for(i=0; i<FD_SETSIZE; ++i) if(FD_ISSET(i, &fsa)) {
sprintf(lmsg, "rc>0, i=%d", i); d(10, lmsg);
if(lmsgd) sprintf(lmsg, "[check_input: frame:%d, isset:i:%d]", frame, i);
  if(i==STDIN_FILENO) { key=c_get_key(); check_key(key); if(lmsgd) strcat(lmsg, "[stdin]"); }
  else if(i==lirc_fd) { key=lirc_parse(); check_key(key); if(lmsgd) strcat(lmsg, "[lird_fd]");  }
  else if(i==oscpslave_fd) { oscpslave_check(); if(lmsgd) strcat(lmsg, "[oscpslave_fd]");  }
  else { if(slave_r(i)>0) slave_parse(); if(lmsgd) strcat(lmsg, "[slave_r]");  }
if(lmsgd) d(10,lmsg);
 }
 if(slave_recv<0 || slave_recv2<0) {
  snprintf(lmsg, 1023, "check_input: slave_recv(1:%d,2:%d), state:%d, ending slave",
   slave_recv, slave_recv2, state); dlog(9,lmsg);
  slave_end(); if(state>=3) action_next(); }
}

/////########
void deinit() { lf("deinit"); int i,j; check_vfstmpname(); slave_end(); free_df();
 for(j=0; j<=5; j++) { i=0; while(param_list[j][i]!=NULL) { free(param_list[j][i]); i++; } }
 mixer_end(); window_end();
 if(wavtmpname[0]!=0) unlink(wavtmpname);
}

/////####################
void panic_child(int sig) { lfd("panic_child",sig);
 lfd("panic_child: parent_said", parent_said);
 lfd("panic_child: parent_ear", parent_ear);
 char lmsg[1024]; lmsg[0]=0;
 cs(" PCH\n");
 signal(sig, SIG_DFL); switch (sig) {
  case SIGSEGV: snprintf(lmsg,1023,"Info: Caught signal child %d SIGSEGV\n",sig); break;
  case SIGINT: snprintf(lmsg,1023,"Info: Caught signal child %d SIGINT\n",sig); break;
  case SIGTERM: snprintf(lmsg,1023,"Info: Caught signal child %d SIGTERM\n",sig); break;
  default: snprintf(lmsg,1023,"Info: Caught signal child %d UNKNOWN\n",sig); break;
 }
 if(lmsg[0]!=0) { if(sig!=15)say(lmsg); cs(lmsg); }
 cs("EOF code: exit (panic_child)\n");
 lfdump();
 exit(-1);
}

/////##############
void panic(int sig) { lfd("panic",sig); if(parent_said>0) { panic_child(sig); return; }
 lfdump();
 deinit(); printf("\n");
 signal(sig, SIG_DFL); switch (sig) {
  case SIGSEGV: printf("Caught signal: %d (SIGSEGV)\n",sig); break;
  case SIGINT: printf("Caught signal: %d (SIGINT)\n",sig); break;
  case SIGTERM: printf("Caught signal: %d (SIGTERM)\n",sig); break;
  default: printf("Caught signal: %d\n",sig); break;
 }
 exit(-1);
}

void noop() { lf("noop"); }
void s_quit(int sig) { lf("s_quit"); signal(sig, SIG_DFL); dlog(0,"s_quit"); conf.quit=1; }

void testf() {
 if(conf.debug==77) {
  blist(d_head, 1);
  blist(f_head, 1);
//  conf.quit=1;
  exit(0);
 }

#if 0
//load_dir("/mnt/_data3/sdb/_src_moje/_audio/oscp/mods"); exit(0);
// char a[1000], b[1000];
// strcpy(b, "      7748  11-18-2003 18:24   sc68files/505 - Checkpoint/Atari ST/Manic (YM Rockerz - 2003).sc68\n"); parse_zip_line(a, b);
// strcpy(b, "      7748  11-18-2003 18:24   sc68files/505 - Checkpoint/Atari ST/bla bla/bla/\n"); parse_zip_line(a, b);
// exit(0);

//get_id3v2(argv[1]);exit(0);
//strcpy(conf.wd, "/mnt/_data3/mule/Incoming/1");
//make_recursive_list(NULL, 0);exit(0);
//for(i=0; i<100; i++) printf("[%2d]", rr(6,12)); exit(0);

#endif
}

////############################
int main(int argc, char *argv[]) { lf("main"); int i=0; srand(time(NULL));
 conf.lines=conf.cols=conf.lw=conf.lh=1; conf.fullpath=2;
 i=load_conf(argc, argv);
 window_init();
 if(i==0) load_dir(""); else load_dir(argv[i]);
 dlog_init(); testf();
 vfstmpname[0]=0; wavtmpname[0]=0;

 signal(SIGSEGV,panic); signal(SIGINT,panic); signal(SIGKILL,panic); signal(SIGTERM,panic);
 signal(SIGPIPE,noop);

 lirc_init(); mixer_init();
 oscpslave_init(); //slave_init();
 if(conf.autoplay) {
  if(conf.file[0]!=0) { ds(2,"autoplay, conf.file", conf.file); action_load();
   if(conf.lastpos>0) { dd(2,"autoplay, conf.lastpos", conf.lastpos); action_seek(conf.lastpos); }
  } else { ds(2, "autoplay", "action_next"); action_next(); }
 }

 i=0; while(conf.quit==0) { i++; check_input(); }

 save_conf();
 if(strstr(listname, "<vplst")!=0) { dlog(9,"main: saving playlist"); save_playlist(); }
 deinit(); return 0;
}
